﻿
Imports PowerLanguage.Function
Imports System.Drawing

Namespace PowerLanguage.Indicator
    Public Class ADXR
        Inherits IndicatorObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_length = 14
        End Sub

        Protected Overrides Sub CalcBar()
            Me.m_value1 = Me.m_dirmovement1.Item(0)
            Me.Plot1.Set(0, Me.m_oadx.Value)
            Me.Plot2.Set(0, Me.m_oadxr.Value)
            If (PublicFunctions.DoubleGreater(Me.m_oadxr.Value, Me.m_oadxr.Item(1)) AndAlso PublicFunctions.DoubleLessEquals(Me.m_oadxr.Item(1), Me.m_oadxr.Item(2))) Then
                MyBase.Alerts.Alert("ADXR turning up", New Object(0  - 1) {})
            ElseIf (PublicFunctions.DoubleLess(Me.m_oadxr.Value, Me.m_oadxr.Item(1)) AndAlso PublicFunctions.DoubleGreaterEquals(Me.m_oadxr.Item(1), Me.m_oadxr.Item(2))) Then
                MyBase.Alerts.Alert("ADXR turning down", New Object(0  - 1) {})
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_dirmovement1 = New DirMovement(Me)
            Me.m_odmiplus = New VariableObject(Of Double)(Me)
            Me.m_odmiminus = New VariableObject(Of Double)(Me)
            Me.m_odmi = New VariableSeries(Of Double)(Me)
            Me.m_oadx = New VariableSeries(Of Double)(Me)
            Me.m_oadxr = New VariableSeries(Of Double)(Me)
            Me.m_ovolty = New VariableSeries(Of Double)(Me)
            Me.Plot1 = MyBase.AddPlot(New PlotAttributes("ADX", EPlotShapes.Line, Color.Cyan, Color.Empty, 0, 0, True))
            Me.Plot2 = MyBase.AddPlot(New PlotAttributes("ADXR", EPlotShapes.Line, Color.Magenta, Color.Empty, 0, 0, True))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_dirmovement1.priceh = MyBase.Bars.High
            Me.m_dirmovement1.pricel = MyBase.Bars.Low
            Me.m_dirmovement1.pricec = MyBase.Bars.Close
            Me.m_dirmovement1.length = New Lambda(Of Integer)(Function() Me.length)
            Me.m_dirmovement1.odmiplus = Me.m_odmiplus
            Me.m_dirmovement1.odmiminus = Me.m_odmiminus
            Me.m_dirmovement1.odmi = Me.m_odmi
            Me.m_dirmovement1.oadx = Me.m_oadx
            Me.m_dirmovement1.oadxr = Me.m_oadxr
            Me.m_dirmovement1.ovolty = Me.m_ovolty
            Me.m_value1 = 0
            Me.m_odmiplus.DefaultValue = 0
            Me.m_odmiminus.DefaultValue = 0
            Me.m_odmi.DefaultValue = 0
            Me.m_oadx.DefaultValue = 0
            Me.m_oadxr.DefaultValue = 0
            Me.m_ovolty.DefaultValue = 0
        End Sub


        ' Properties
        <Input()> _
        Public Property length As Integer
            Get
                Return Me.m_length
            End Get
            Set(ByVal value As Integer)
                Me.m_length = value
            End Set
        End Property


        ' Fields
        Private m_dirmovement1 As DirMovement
        Private m_length As Integer
        Private m_oadx As VariableSeries(Of Double)
        Private m_oadxr As VariableSeries(Of Double)
        Private m_odmi As VariableSeries(Of Double)
        Private m_odmiminus As VariableObject(Of Double)
        Private m_odmiplus As VariableObject(Of Double)
        Private m_ovolty As VariableSeries(Of Double)
        Private m_value1 As Double
        Private Plot1 As IPlotObject
        Private Plot2 As IPlotObject
    End Class
End Namespace

