﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System
Imports System.Drawing

Namespace PowerLanguage.Indicator
    Public Class Accum_Dist__PrVol
        Inherits IndicatorObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_alertlength = 14
        End Sub

        Protected Overrides Sub CalcBar()
            Dim resolution As EResolution = MyBase.Bars.Info.Resolution.Type
            If ((((EResolution.Day = resolution) OrElse (EResolution.Week = resolution)) OrElse ((EResolution.Month = resolution) OrElse (EResolution.Quarter = resolution))) OrElse (EResolution.Year = resolution)) Then
                Me.m_anyvol.Value = MyBase.Bars.Volume.Item(0)
            Else
                Me.m_anyvol.Value = MyBase.Bars.Ticks.Item(0)
            End If
            Me.m_accdstprvol.Value = Me.m_accumdist1.Item(0)
            Me.Plot1.Set(0, Me.m_accdstprvol.Value)
            If ((Me.m_lowestbar1.Item(0) = 0) AndAlso PublicFunctions.DoubleGreater(Me.m_lowestbar2.Item(0), 0)) Then
                MyBase.Alerts.Alert("Bullish divergence - new low not confirmed", New Object(0 - 1) {})
            ElseIf ((Me.m_highestbar1.Item(0) = 0) AndAlso PublicFunctions.DoubleGreater(Me.m_highestbar2.Item(0), 0)) Then
                MyBase.Alerts.Alert("Bearish divergence - new high not confirmed", New Object(0 - 1) {})
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_accumdist1 = New AccumulationDistribution(Me)
            Me.m_lowestbar1 = New LowestBar(Me)
            Me.m_lowestbar2 = New LowestBar(Me)
            Me.m_highestbar1 = New HighestBar(Me)
            Me.m_highestbar2 = New HighestBar(Me)
            Me.m_anyvol = New VariableSeries(Of Double)(Me)
            Me.m_accdstprvol = New VariableSeries(Of Double)(Me)
            Me.Plot1 = MyBase.AddPlot(New PlotAttributes("AccDst-PrVol", EPlotShapes.Line, Color.Blue, Color.Empty, 0, 0, True))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_accumdist1.AnyVolume = Me.m_anyvol
            Me.m_lowestbar1.price = MyBase.Bars.Close
            Me.m_lowestbar1.length = New Lambda(Of Integer)( Function() Me.alertlength)
            Me.m_lowestbar2.price = Me.m_accdstprvol
            Me.m_lowestbar2.length = New Lambda(Of Integer)( Function() Me.alertlength)
            Me.m_highestbar1.price = MyBase.Bars.Close
            Me.m_highestbar1.length = New Lambda(Of Integer)( Function() Me.alertlength)
            Me.m_highestbar2.price = Me.m_accdstprvol
            Me.m_highestbar2.length = New Lambda(Of Integer)( Function() Me.alertlength)
            Me.m_anyvol.DefaultValue = 0
            Me.m_accdstprvol.DefaultValue = 0
        End Sub


        ' Properties
        <Input()> _
        Public Property alertlength As Integer
            Get
                Return Me.m_alertlength
            End Get
            Set(ByVal value As Integer)
                Me.m_alertlength = value
            End Set
        End Property


        ' Fields
        Private m_accdstprvol As VariableSeries(Of Double)
        Private m_accumdist1 As AccumulationDistribution
        Private m_alertlength As Integer
        Private m_anyvol As VariableSeries(Of Double)
        Private m_highestbar1 As HighestBar
        Private m_highestbar2 As HighestBar
        Private m_lowestbar1 As LowestBar
        Private m_lowestbar2 As LowestBar
        Private Plot1 As IPlotObject
    End Class
End Namespace

