﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System
Imports System.Drawing

Namespace PowerLanguage.Indicator
    Public Class AdvanceDecl_Ratio
        Inherits IndicatorObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
        End Sub

        Protected Overrides Sub CalcBar()
            Me.m_advdecl = Me.m_advancedeclineratio1.Item(0)
            Me.Plot1.Set(0, Me.m_advdecl)
            Me.Plot2.Set(0, 1)
        End Sub

        Protected Overrides Sub Create()
            Me.m_advancedeclineratio1 = New AdvanceDeclineRatio(Me)
            Me.Plot1 = MyBase.AddPlot(New PlotAttributes("A/DRatio", EPlotShapes.Line, Color.Yellow, Color.Empty, 0, 0, True))
            Me.Plot2 = MyBase.AddPlot(New PlotAttributes("Baseline", EPlotShapes.Line, Color.Green, Color.Empty, 0, 0, True))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_advissues = MyBase.Bars.Close
            Me.m_decissues = MyBase.BarsOfData(2).Close
            Me.m_advancedeclineratio1.advissues = Me.advissues
            Me.m_advancedeclineratio1.decissues = Me.decissues
            Me.m_advdecl = 0
        End Sub


        ' Properties
        Private ReadOnly Property advissues As ISeries(Of Double)
            Get
                Return Me.m_advissues
            End Get
        End Property

        Private ReadOnly Property decissues As ISeries(Of Double)
            Get
                Return Me.m_decissues
            End Get
        End Property


        ' Fields
        Private m_advancedeclineratio1 As AdvanceDeclineRatio
        Private m_advdecl As Double
        Private m_advissues As ISeries(Of Double)
        Private m_decissues As ISeries(Of Double)
        Private Plot1 As IPlotObject
        Private Plot2 As IPlotObject
    End Class
End Namespace

