﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System
Imports System.Drawing

Namespace PowerLanguage.Indicator
    Public Class Arms_Index_TRIN
        Inherits IndicatorObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_smoothinglength = 4
            Me.m_oversold = 1.25
            Me.m_overbought = 0.7
        End Sub

        Protected Overrides Sub CalcBar()
            Me.m_trin.Value = Me.m_armsindex1.Item(0)
            Me.m_avgtrin.Value = PublicFunctions.Average(Me.m_trin, Me.smoothinglength)
            Me.Plot1.Set(0, Me.m_trin.Value)
            Me.Plot2.Set(0, Me.m_avgtrin.Value)
            Me.Plot3.Set(0, Me.oversold)
            Me.Plot4.Set(0, Me.overbought)
            If Me.CrossesUnder(Me.m_avgtrin, New Lambda(Of Double)( Function() Me.oversold)) Then
                MyBase.Alerts.Alert("Indicator exiting oversold zone", New Object(0 - 1) {})
            ElseIf Me.CrossesOver(Me.m_avgtrin, New Lambda(Of Double)( Function() Me.overbought)) Then
                MyBase.Alerts.Alert("Indicator exiting overbought zone", New Object(0 - 1) {})
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_armsindex1 = New ArmsIndex(Me)
            Me.m_trin = New VariableSeries(Of Double)(Me)
            Me.m_avgtrin = New VariableSeries(Of Double)(Me)
            Me.Plot1 = MyBase.AddPlot(New PlotAttributes("ArmsX", EPlotShapes.Line, Color.Yellow, Color.Empty, 0, 0, True))
            Me.Plot2 = MyBase.AddPlot(New PlotAttributes("ArmsXAvg", EPlotShapes.Line, Color.Magenta, Color.Empty, 0, 0, True))
            Me.Plot3 = MyBase.AddPlot(New PlotAttributes("OverSld", EPlotShapes.Line, Color.Green, Color.Empty, 0, 0, True))
            Me.Plot4 = MyBase.AddPlot(New PlotAttributes("OverBot", EPlotShapes.Line, Color.Green, Color.Empty, 0, 0, True))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_advissues = MyBase.Bars.Close
            Me.m_advvol = MyBase.BarsOfData(2).Close
            Me.m_decissues = MyBase.BarsOfData(3).Close
            Me.m_decvol = MyBase.BarsOfData(4).Close
            Me.m_armsindex1.advissues = Me.advissues
            Me.m_armsindex1.advvolume = Me.advvol
            Me.m_armsindex1.decissues = Me.decissues
            Me.m_armsindex1.decvolume = Me.decvol
            Me.m_trin.DefaultValue = 0
            Me.m_avgtrin.DefaultValue = 0
        End Sub


        ' Properties
        Private ReadOnly Property advissues As ISeries(Of Double)
            Get
                Return Me.m_advissues
            End Get
        End Property

        Private ReadOnly Property advvol As ISeries(Of Double)
            Get
                Return Me.m_advvol
            End Get
        End Property

        Private ReadOnly Property decissues As ISeries(Of Double)
            Get
                Return Me.m_decissues
            End Get
        End Property

        Private ReadOnly Property decvol As ISeries(Of Double)
            Get
                Return Me.m_decvol
            End Get
        End Property

        <Input()> _
        Public Property overbought As Double
            Get
                Return Me.m_overbought
            End Get
            Set(ByVal value As Double)
                Me.m_overbought = value
            End Set
        End Property

        <Input()> _
        Public Property oversold As Double
            Get
                Return Me.m_oversold
            End Get
            Set(ByVal value As Double)
                Me.m_oversold = value
            End Set
        End Property

        <Input()> _
        Public Property smoothinglength As Integer
            Get
                Return Me.m_smoothinglength
            End Get
            Set(ByVal value As Integer)
                Me.m_smoothinglength = value
            End Set
        End Property


        ' Fields
        Private m_advissues As ISeries(Of Double)
        Private m_advvol As ISeries(Of Double)
        Private m_armsindex1 As ArmsIndex
        Private m_avgtrin As VariableSeries(Of Double)
        Private m_decissues As ISeries(Of Double)
        Private m_decvol As ISeries(Of Double)
        Private m_overbought As Double
        Private m_oversold As Double
        Private m_smoothinglength As Integer
        Private m_trin As VariableSeries(Of Double)
        Private Plot1 As IPlotObject
        Private Plot2 As IPlotObject
        Private Plot3 As IPlotObject
        Private Plot4 As IPlotObject
    End Class
End Namespace

