﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System
Imports System.Drawing

Namespace PowerLanguage.Indicator
    Public Class Average_True_Range
        Inherits IndicatorObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_atrlength = 14
            Me.m_alertlength = 14
        End Sub

        Protected Overrides Sub CalcBar()
            Me.m_atr.Value = Me.m_avgtruerange1.Item(0)
            Me.Plot1.Set(0, Me.m_atr.Value)
            If (Me.m_highestbar1.Item(0) = 0) Then
                MyBase.Alerts.Alert("Indicator at high", New Object(0  - 1) {})
            ElseIf (Me.m_lowestbar1.Item(0) = 0) Then
                MyBase.Alerts.Alert("Indicator at low", New Object(0  - 1) {})
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_avgtruerange1 = New AvgTrueRange(Me)
            Me.m_highestbar1 = New HighestBar(Me)
            Me.m_lowestbar1 = New LowestBar(Me)
            Me.m_atr = New VariableSeries(Of Double)(Me)
            Me.Plot1 = MyBase.AddPlot(New PlotAttributes("ATR", EPlotShapes.Line, Color.Cyan, Color.Empty, 0, 0, True))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_avgtruerange1.length = New Lambda(Of Integer)( Function() Me.atrlength)
            Me.m_highestbar1.price = Me.m_atr
            Me.m_highestbar1.length = New Lambda(Of Integer)( Function() Me.alertlength)
            Me.m_lowestbar1.price = Me.m_atr
            Me.m_lowestbar1.length = New Lambda(Of Integer)( Function() Me.alertlength)
            Me.m_atr.DefaultValue = 0
        End Sub


        ' Properties
        <Input()> _
        Public Property alertlength As Integer
            Get
                Return Me.m_alertlength
            End Get
            Set(ByVal value As Integer)
                Me.m_alertlength = value
            End Set
        End Property

        <Input()> _
        Public Property atrlength As Integer
            Get
                Return Me.m_atrlength
            End Get
            Set(ByVal value As Integer)
                Me.m_atrlength = value
            End Set
        End Property


        ' Fields
        Private m_alertlength As Integer
        Private m_atr As VariableSeries(Of Double)
        Private m_atrlength As Integer
        Private m_avgtruerange1 As AvgTrueRange
        Private m_highestbar1 As HighestBar
        Private m_lowestbar1 As LowestBar
        Private Plot1 As IPlotObject
    End Class
End Namespace

