﻿Imports PowerLanguage
Imports System
Imports System.Drawing

Namespace PowerLanguage.Indicator
    <SameAsSymbol(True)> _
    Public Class Bid_And_Ask
        Inherits IndicatorObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
        End Sub

        Protected Overrides Sub CalcBar()
            If MyBase.Environment.IsRealTimeCalc Then
                Me.m_bidvalue = MyBase.Bars.StatusLine.Bid
                Me.m_askvalue = MyBase.Bars.StatusLine.Ask
                Me.Plot1.Set(0, Me.m_bidvalue)
                Me.Plot2.Set(0, Me.m_askvalue)
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.Plot1 = MyBase.AddPlot(New PlotAttributes("Bid", EPlotShapes.Line, Color.Yellow, Color.Empty, 0, 0, True))
            Me.Plot2 = MyBase.AddPlot(New PlotAttributes("Ask", EPlotShapes.Line, Color.Cyan, Color.Empty, 0, 0, True))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_bidvalue = 0
            Me.m_askvalue = 0
        End Sub


        ' Fields
        Private m_askvalue As Double
        Private m_bidvalue As Double
        Private Plot1 As IPlotObject
        Private Plot2 As IPlotObject
    End Class
End Namespace

