﻿Imports PowerLanguage
Imports System
Imports System.Drawing

Namespace PowerLanguage.Indicator
    Public Class Bid_And_Ask_Vol_Ratio
        Inherits IndicatorObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_datanum = 1
            Me.m_uselog = True
        End Sub

        Protected Overrides Sub CalcBar()
            If (MyBase.Bars.LastBarOnChart AndAlso (MyBase.Bars.Status <> EBarState.Close)) Then
                Dim resolution As EResolution = MyBase.Bars.Info.Resolution.Type
                If ((((EResolution.Day = resolution) OrElse (EResolution.Week = resolution)) OrElse ((EResolution.Month = resolution) OrElse (EResolution.Quarter = resolution))) OrElse (EResolution.Year = resolution)) Then
                    Me.m_myvol = MyBase.Bars.Volume.Item(0)
                Else
                    Me.m_myvol = MyBase.Bars.Ticks.Item(0)
                End If
                If (MyBase.Bars.CurrentBar > Me.m_mycurrentbar.Value) Then
                    Me.m_volumeatbid.Value = 0
                    Me.m_volumeatask.Value = 0
                    Me.m_bavolratio.Value = 0
                    Me.m_voltmp.Value = 0
                    Me.m_mycurrentbar.Value = MyBase.Bars.CurrentBar
                End If
                If PublicFunctions.DoubleLess(MyBase.Bars.StatusLine.Bid, MyBase.Bars.StatusLine.Ask) Then
                    If PublicFunctions.DoubleLessEquals(MyBase.Bars.Close.Item(0), MyBase.Bars.StatusLine.Bid) Then
                        Me.m_volumeatbid.Value = ((Me.m_volumeatbid.Value + Me.m_myvol) - Me.m_voltmp.Value)
                    ElseIf PublicFunctions.DoubleGreaterEquals(MyBase.Bars.Close.Item(0), MyBase.Bars.StatusLine.Ask) Then
                        Me.m_volumeatask.Value = ((Me.m_volumeatask.Value + Me.m_myvol) - Me.m_voltmp.Value)
                    End If
                End If
                If (PublicFunctions.DoubleGreater(Me.m_volumeatbid.Value, 0) AndAlso PublicFunctions.DoubleGreater(Me.m_volumeatask.Value, 0)) Then
                    Me.m_bavolratio.Value = PublicFunctions.Iff(Of Double)(Me.uselog, Math.Log((Me.m_volumeatask.Value / Me.m_volumeatbid.Value)), (Me.m_volumeatask.Value / Me.m_volumeatbid.Value))
                End If
                Me.m_voltmp.Value = Me.m_myvol
                Me.Plot1.Set(0, Me.m_bavolratio.Value)
            End If
            Me.Plot2.Set(0, 0)
        End Sub

        Protected Overrides Sub Create()
            Me.m_mycurrentbar = New VariableObject(Of Integer)(Me)
            Me.m_volumeatbid = New VariableObject(Of Double)(Me)
            Me.m_volumeatask = New VariableObject(Of Double)(Me)
            Me.m_bavolratio = New VariableObject(Of Double)(Me)
            Me.m_voltmp = New VariableObject(Of Double)(Me)
            Me.Plot1 = MyBase.AddPlot(New PlotAttributes("BAVolRatio", EPlotShapes.Histogram, Color.Blue, Color.Empty, 0, 0, True))
            Me.Plot2 = MyBase.AddPlot(New PlotAttributes("ZeroLine", EPlotShapes.Line, Color.Green, Color.Empty, 0, 0, True))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_myvol = 0
            Me.m_mycurrentbar.DefaultValue = 0
            Me.m_volumeatbid.DefaultValue = 0
            Me.m_volumeatask.DefaultValue = 0
            Me.m_bavolratio.DefaultValue = 0
            Me.m_voltmp.DefaultValue = 0
        End Sub


        ' Properties
        <Input()> _
        Public Property datanum As Double
            Get
                Return Me.m_datanum
            End Get
            Set(ByVal value As Double)
                Me.m_datanum = value
            End Set
        End Property

        <Input()> _
        Public Property uselog As Boolean
            Get
                Return Me.m_uselog
            End Get
            Set(ByVal value As Boolean)
                Me.m_uselog = value
            End Set
        End Property


        ' Fields
        Private m_bavolratio As VariableObject(Of Double)
        Private m_datanum As Double
        Private m_mycurrentbar As VariableObject(Of Integer)
        Private m_myvol As Double
        Private m_uselog As Boolean
        Private m_voltmp As VariableObject(Of Double)
        Private m_volumeatask As VariableObject(Of Double)
        Private m_volumeatbid As VariableObject(Of Double)
        Private Plot1 As IPlotObject
        Private Plot2 As IPlotObject
    End Class
End Namespace

