﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System
Imports System.Drawing

Namespace PowerLanguage.Indicator
    Public Class CCI_Average
        Inherits IndicatorObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_ccilength = 14
            Me.m_cciavglength = 9
            Me.m_oversold = -100
            Me.m_overbought = 100
        End Sub

        Protected Overrides Sub CalcBar()
            Me.m_ccivalue.Value = Me.m_cci1.Item(0)
            Me.m_cciavg.Value = PublicFunctions.Average(Me.m_ccivalue, Me.cciavglength)
            Me.Plot1.Set(0, Me.m_ccivalue.Value)
            Me.Plot2.Set(0, Me.m_cciavg.Value)
            Me.Plot3.Set(0, Me.overbought)
            Me.Plot4.Set(0, Me.oversold)
            If Me.CrossesOver(Me.m_cciavg, New Lambda(Of Double)( Function() Me.oversold)) Then
                MyBase.Alerts.Alert("Indicator exiting oversold zone", New Object(0 - 1) {})
            ElseIf Me.CrossesUnder(Me.m_cciavg, New Lambda(Of Double)( Function() Me.overbought)) Then
                MyBase.Alerts.Alert("Indicator exiting overbought zone", New Object(0 - 1) {})
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_cci1 = New CCI(Me)
            Me.m_ccivalue = New VariableSeries(Of Double)(Me)
            Me.m_cciavg = New VariableSeries(Of Double)(Me)
            Me.Plot1 = MyBase.AddPlot(New PlotAttributes("CCI", EPlotShapes.Line, Color.Cyan, Color.Empty, 0, 0, True))
            Me.Plot2 = MyBase.AddPlot(New PlotAttributes("CCIAvg", EPlotShapes.Line, Color.Blue, Color.Empty, 0, 0, True))
            Me.Plot3 = MyBase.AddPlot(New PlotAttributes("OverBot", EPlotShapes.Line, Color.Green, Color.Empty, 0, 0, True))
            Me.Plot4 = MyBase.AddPlot(New PlotAttributes("OverSld", EPlotShapes.Line, Color.Green, Color.Empty, 0, 0, True))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_cci1.length = New Lambda(Of Integer)( Function() Me.ccilength)
            Me.m_ccivalue.DefaultValue = 0
            Me.m_cciavg.DefaultValue = 0
        End Sub


        ' Properties
        <Input()> _
        Public Property cciavglength As Integer
            Get
                Return Me.m_cciavglength
            End Get
            Set(ByVal value As Integer)
                Me.m_cciavglength = value
            End Set
        End Property

        <Input()> _
        Public Property ccilength As Integer
            Get
                Return Me.m_ccilength
            End Get
            Set(ByVal value As Integer)
                Me.m_ccilength = value
            End Set
        End Property

        <Input()> _
        Public Property overbought As Double
            Get
                Return Me.m_overbought
            End Get
            Set(ByVal value As Double)
                Me.m_overbought = value
            End Set
        End Property

        <Input()> _
        Public Property oversold As Double
            Get
                Return Me.m_oversold
            End Get
            Set(ByVal value As Double)
                Me.m_oversold = value
            End Set
        End Property


        ' Fields
        Private m_cci1 As CCI
        Private m_cciavg As VariableSeries(Of Double)
        Private m_cciavglength As Integer
        Private m_ccilength As Integer
        Private m_ccivalue As VariableSeries(Of Double)
        Private m_overbought As Double
        Private m_oversold As Double
        Private Plot1 As IPlotObject
        Private Plot2 As IPlotObject
        Private Plot3 As IPlotObject
        Private Plot4 As IPlotObject
    End Class
End Namespace

