﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System
Imports System.Drawing

Namespace PowerLanguage.Indicator
    <SameAsSymbol(True)> _
    Public Class C_PierceLine_DkCloud
        Inherits IndicatorObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_length = 14
        End Sub

        Protected Overrides Sub CalcBar()
            Me.m_value1 = Me.m_c_pierceline_dkcloud1.Item(0)
            If (Me.m_opiercingline.Value = 1) Then
                Me.Plot1.Set(0, MyBase.Bars.High.Item(0))
                MyBase.Alerts.Alert("PiercingLine", New Object(0  - 1) {})
            ElseIf (Me.m_odarkcloud.Value = 1) Then
                Me.Plot2.Set(0, MyBase.Bars.Low.Item(0))
                MyBase.Alerts.Alert("DarkCloud", New Object(0  - 1) {})
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_c_pierceline_dkcloud1 = New PowerLanguage.Function.C_PierceLine_DkCloud(Me)
            Me.m_opiercingline = New VariableObject(Of Double)(Me)
            Me.m_odarkcloud = New VariableObject(Of Double)(Me)
            Me.Plot1 = MyBase.AddPlot(New PlotAttributes("PierceLine", EPlotShapes.Point, Color.Yellow, Color.Empty, 4, 0, True))
            Me.Plot2 = MyBase.AddPlot(New PlotAttributes("DkCloud", EPlotShapes.Point, Color.Magenta, Color.Empty, 4, 0, True))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_c_pierceline_dkcloud1.length = Me.length
            Me.m_c_pierceline_dkcloud1.opiercingline = Me.m_opiercingline
            Me.m_c_pierceline_dkcloud1.odarkcloud = Me.m_odarkcloud
            Me.m_value1 = 0
            Me.m_opiercingline.DefaultValue = 0
            Me.m_odarkcloud.DefaultValue = 0
        End Sub


        ' Properties
        <Input()> _
        Public Property length As Integer
            Get
                Return Me.m_length
            End Get
            Set(ByVal value As Integer)
                Me.m_length = value
            End Set
        End Property


        ' Fields
        Private m_c_pierceline_dkcloud1 As PowerLanguage.Function.C_PierceLine_DkCloud
        Private m_length As Integer
        Private m_odarkcloud As VariableObject(Of Double)
        Private m_opiercingline As VariableObject(Of Double)
        Private m_value1 As Double
        Private Plot1 As IPlotObject
        Private Plot2 As IPlotObject
    End Class
End Namespace

