﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System
Imports System.Drawing

Namespace PowerLanguage.Indicator
    <SameAsSymbol(True)> _
    Public Class Chaos_Fractals
        Inherits IndicatorObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_strength = 2
        End Sub

        Protected Overrides Sub CalcBar()
            Me.m_value1 = Me.m_swinghigh1.Item(0)
            Me.m_value2 = Me.m_swinglow1.Item(0)
            If PublicFunctions.DoubleGreater(Me.m_value1, -1) Then
                Me.Plot1.Set(0, Me.m_value1)
            End If
            If PublicFunctions.DoubleGreater(Me.m_value2, -1) Then
                Me.Plot2.Set(0, Me.m_value2)
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_swinghigh1 = New SwingHigh(Me)
            Me.m_swinglow1 = New SwingLow(Me)
            Me.Plot1 = MyBase.AddPlot(New PlotAttributes("BuyFractal", EPlotShapes.Point, Color.Lime, Color.Empty, 1, 0, True))
            Me.Plot2 = MyBase.AddPlot(New PlotAttributes("SellFractal", EPlotShapes.Point, ColorTranslator.FromWin32(&HE84FF0), Color.Empty, 1, 0, True))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_swinghigh1.instance = New ConstantObject(Of Integer)(1)
            Me.m_swinghigh1.price = MyBase.Bars.High
            Me.m_swinghigh1.strength = New Lambda(Of Integer)( Function() Me.strength)
            Me.m_swinghigh1.length = New ConstantObject(Of Integer)(80)
            Me.m_swinglow1.instance = New ConstantObject(Of Integer)(1)
            Me.m_swinglow1.price = MyBase.Bars.Low
            Me.m_swinglow1.strength = New Lambda(Of Integer)( Function() Me.strength)
            Me.m_swinglow1.length = New ConstantObject(Of Integer)(80)
            Me.m_value1 = 0
            Me.m_value2 = 0
        End Sub


        ' Properties
        <Input> _
        Public Property strength As Integer
            Get
                Return Me.m_strength
            End Get
            Set(ByVal value As Integer)
                Me.m_strength = value
            End Set
        End Property


        ' Fields
        Private m_strength As Integer
        Private m_swinghigh1 As SwingHigh
        Private m_swinglow1 As SwingLow
        Private m_value1 As Double
        Private m_value2 As Double
        Private Plot1 As IPlotObject
        Private Plot2 As IPlotObject
    End Class
End Namespace

