﻿Imports PowerLanguage
Imports System
Imports System.Drawing

Namespace PowerLanguage.Indicator
    Public Class Chaos_Gator
        Inherits IndicatorObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_jaw = 13
            Me.m_jawoffset = 8
            Me.m_teeth = 8
            Me.m_teethoffset = 5
            Me.m_lip = 5
            Me.m_lipoffset = 3
            Me.m_valueup = Color.FromKnownColor(KnownColor.Green)
            Me.m_valuedown = Color.Red
        End Sub

        Protected Overrides Sub CalcBar()
            Me.m_value1 = PublicFunctions.Average(Me.value, Me.jaw, Me.jawoffset)
            Me.m_value2 = PublicFunctions.Average(Me.value, Me.teeth, Me.teethoffset)
            Me.m_value3 = PublicFunctions.Average(Me.value, Me.lip, Me.lipoffset)
            If (MyBase.Bars.CurrentBar >= &H15) Then
                Me.m_value11.Value = Math.Abs(CDbl((Me.m_value1 - Me.m_value2)))
                If PublicFunctions.DoubleGreater(Me.m_value11.Value, Me.m_value11.Item(1)) Then
                    Me.Plot1.Set(0, Me.m_value11.Value, Me.m_valueup)
                Else
                    Me.Plot1.Set(0, Me.m_value11.Value, Me.m_valuedown)
                End If
                Me.m_value12.Value = (-1 * Math.Abs(CDbl((Me.m_value2 - Me.m_value3))))
                If PublicFunctions.DoubleGreater(Me.m_value12.Value, Me.m_value12.Item(1)) Then
                    Me.Plot2.Set(0, Me.m_value12.Value, Me.m_valueup)
                Else
                    Me.Plot2.Set(0, Me.m_value12.Value, Me.m_valuedown)
                End If
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_value11 = New VariableSeries(Of Double)(Me)
            Me.m_value12 = New VariableSeries(Of Double)(Me)
            Me.Plot1 = MyBase.AddPlot(New PlotAttributes("BLblue", EPlotShapes.Histogram, Color.Blue, Color.Empty, 0, 0, True))
            Me.Plot2 = MyBase.AddPlot(New PlotAttributes("BLred", EPlotShapes.Histogram, Color.Red, Color.Empty, 0, 0, True))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_value = New Lambda(Of Double)(Function(_bb) ((MyBase.Bars.High.Item(_bb) + MyBase.Bars.Low.Item(_bb)) / 2))
            Me.m_value1 = 0
            Me.m_value2 = 0
            Me.m_value3 = 0
            Me.m_value11.DefaultValue = 0
            Me.m_value12.DefaultValue = 0
        End Sub


        ' Properties
        <Input()> _
        Public Property jaw As Integer
            Get
                Return Me.m_jaw
            End Get
            Set(ByVal value As Integer)
                Me.m_jaw = value
            End Set
        End Property

        <Input()> _
        Public Property jawoffset As Integer
            Get
                Return Me.m_jawoffset
            End Get
            Set(ByVal value As Integer)
                Me.m_jawoffset = value
            End Set
        End Property

        <Input()> _
        Public Property lip As Integer
            Get
                Return Me.m_lip
            End Get
            Set(ByVal value As Integer)
                Me.m_lip = value
            End Set
        End Property

        <Input()> _
        Public Property lipoffset As Integer
            Get
                Return Me.m_lipoffset
            End Get
            Set(ByVal value As Integer)
                Me.m_lipoffset = value
            End Set
        End Property

        <Input()> _
        Public Property teeth As Integer
            Get
                Return Me.m_teeth
            End Get
            Set(ByVal value As Integer)
                Me.m_teeth = value
            End Set
        End Property

        <Input()> _
        Public Property teethoffset As Integer
            Get
                Return Me.m_teethoffset
            End Get
            Set(ByVal value As Integer)
                Me.m_teethoffset = value
            End Set
        End Property

        Private ReadOnly Property value As ISeries(Of Double)
            Get
                Return Me.m_value
            End Get
        End Property

        <Input()> _
        Public Property valuedown As KnownColor
            Get
                Return Me.m_valuedown.ToKnownColor
            End Get
            Set(ByVal value As KnownColor)
                Me.m_valuedown = Color.FromKnownColor(value)
            End Set
        End Property

        <Input()> _
        Public Property valueup As KnownColor
            Get
                Return Me.m_valueup.ToKnownColor
            End Get
            Set(ByVal value As KnownColor)
                Me.m_valueup = Color.FromKnownColor(value)
            End Set
        End Property


        ' Fields
        Private m_jaw As Integer
        Private m_jawoffset As Integer
        Private m_lip As Integer
        Private m_lipoffset As Integer
        Private m_teeth As Integer
        Private m_teethoffset As Integer
        Private m_value As ISeries(Of Double)
        Private m_value1 As Double
        Private m_value11 As VariableSeries(Of Double)
        Private m_value12 As VariableSeries(Of Double)
        Private m_value2 As Double
        Private m_value3 As Double
        Private m_valuedown As Color
        Private m_valueup As Color
        Private Plot1 As IPlotObject
        Private Plot2 As IPlotObject
    End Class
End Namespace

