﻿Imports PowerLanguage
Imports System
Imports System.Drawing

Namespace PowerLanguage.Indicator
    <SameAsSymbol(True)> _
    Public Class Consecutive_Downs
        Inherits IndicatorObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_consecutivebarsdown = 3
        End Sub

        Protected Overrides Sub CalcBar()
            If PublicFunctions.DoubleLess(Me.price.Item(0), Me.price.Item(1)) Then
                Me.m_value1.Value = (Me.m_value1.Value + 1)
            Else
                Me.m_value1.Value = 0
            End If
            If PublicFunctions.DoubleGreaterEquals(Me.m_value1.Value, Me.consecutivebarsdown) Then
                Me.Plot1.Set(0, MyBase.Bars.Low.Item(0))
                MyBase.Alerts.Alert
            Else
                Me.Plot1.Reset
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_value1 = New VariableObject(Of Double)(Me)
            Me.Plot1 = MyBase.AddPlot(New PlotAttributes("ConsecDn", EPlotShapes.Point, Color.Blue, Color.Empty, 4, 0, True))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_price = MyBase.Bars.Close
            Me.m_value1.DefaultValue = 0
        End Sub


        ' Properties
        <Input()> _
        Public Property consecutivebarsdown As Double
            Get
                Return Me.m_consecutivebarsdown
            End Get
            Set(ByVal value As Double)
                Me.m_consecutivebarsdown = value
            End Set
        End Property

        Private ReadOnly Property price As ISeries(Of Double)
            Get
                Return Me.m_price
            End Get
        End Property


        ' Fields
        Private m_consecutivebarsdown As Double
        Private m_price As ISeries(Of Double)
        Private m_value1 As VariableObject(Of Double)
        Private Plot1 As IPlotObject
    End Class
End Namespace

