﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System
Imports System.Drawing

Namespace PowerLanguage.Indicator
    Public Class Correlation
        Inherits IndicatorObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_length = 14
            Me.m_poscorralert = 0.7
            Me.m_negcorralert = -0.7
        End Sub

        Protected Overrides Sub CalcBar()
            Me.m_correlval.Value = Me.m_correlation1.Item(0)
            Me.Plot1.Set(0, Me.m_correlval.Value)
            Me.Plot2.Set(0, Me.poscorralert)
            Me.Plot3.Set(0, Me.negcorralert)
            If Me.CrossesOver(Me.m_correlval, New Lambda(Of Double)( Function() Me.poscorralert)) Then
                MyBase.Alerts.Alert("Positive correlation alert", New Object(0 - 1) {})
            ElseIf Me.CrossesUnder(Me.m_correlval, New Lambda(Of Double)( Function() Me.negcorralert)) Then
                MyBase.Alerts.Alert("Negative correlation alert", New Object(0 - 1) {})
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_correlation1 = New PowerLanguage.Function.Correlation(Me)
            Me.m_correlval = New VariableSeries(Of Double)(Me)
            Me.Plot1 = MyBase.AddPlot(New PlotAttributes("Correl", EPlotShapes.Line, Color.Yellow, Color.Empty, 0, 0, True))
            Me.Plot2 = MyBase.AddPlot(New PlotAttributes("PosCorrAlert", EPlotShapes.Line, Color.Green, Color.Empty, 0, 0, True))
            Me.Plot3 = MyBase.AddPlot(New PlotAttributes("NegCorrAlert", EPlotShapes.Line, Color.Green, Color.Empty, 0, 0, True))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_indepdata = MyBase.Bars.Close
            Me.m_depdata = MyBase.BarsOfData(2).Close
            Me.m_correlation1.indep = Me.indepdata
            Me.m_correlation1.dep = Me.depdata
            Me.m_correlation1.length = New Lambda(Of Integer)( Function() Me.length)
            Me.m_correlval.DefaultValue = 0
        End Sub


        ' Properties
        Private ReadOnly Property depdata As ISeries(Of Double)
            Get
                Return Me.m_depdata
            End Get
        End Property

        Private ReadOnly Property indepdata As ISeries(Of Double)
            Get
                Return Me.m_indepdata
            End Get
        End Property

        <Input()> _
        Public Property length As Integer
            Get
                Return Me.m_length
            End Get
            Set(ByVal value As Integer)
                Me.m_length = value
            End Set
        End Property

        <Input()> _
        Public Property negcorralert As Double
            Get
                Return Me.m_negcorralert
            End Get
            Set(ByVal value As Double)
                Me.m_negcorralert = value
            End Set
        End Property

        <Input()> _
        Public Property poscorralert As Double
            Get
                Return Me.m_poscorralert
            End Get
            Set(ByVal value As Double)
                Me.m_poscorralert = value
            End Set
        End Property


        ' Fields
        Private m_correlation1 As PowerLanguage.Function.Correlation
        Private m_correlval As VariableSeries(Of Double)
        Private m_depdata As ISeries(Of Double)
        Private m_indepdata As ISeries(Of Double)
        Private m_length As Integer
        Private m_negcorralert As Double
        Private m_poscorralert As Double
        Private Plot1 As IPlotObject
        Private Plot2 As IPlotObject
        Private Plot3 As IPlotObject
    End Class
End Namespace

