﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System
Imports System.Drawing

Namespace PowerLanguage.Indicator
    <SameAsSymbol(True)> _
    Public Class Count_Criteria_PB
        Inherits IndicatorObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_length = 14
            Me.m_occur = 7
        End Sub

        Protected Overrides Sub CalcBar()
            If PublicFunctions.DoubleGreaterEquals(CDbl(Me.m_countif1.Item(0)), Me.occur) Then
                Me.Plot1.Set(0, MyBase.Bars.High.Item(0))
                Me.Plot2.Set(0, MyBase.Bars.Low.Item(0))
                MyBase.Alerts.Alert
            Else
                Me.Plot1.Reset
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_countif1 = New CountIf(Me)
            Me.Plot1 = MyBase.AddPlot(New PlotAttributes("Plot1", EPlotShapes.BarHigh, Color.Cyan, Color.Empty, 0, 0, True))
            Me.Plot2 = MyBase.AddPlot(New PlotAttributes("Plot2", EPlotShapes.BarLow, Color.Cyan, Color.Empty, 0, 0, True))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_criteria = New Lambda(Of Boolean)(Function(_bb) PublicFunctions.DoubleGreater(MyBase.Bars.Close.Item(_bb), MyBase.Bars.High.Item((1 + _bb))))
            Me.m_countif1.test = Me.criteria
            Me.m_countif1.length = New Lambda(Of Integer)( Function() Me.length)
        End Sub


        ' Properties
        Private ReadOnly Property criteria As ISeries(Of Boolean)
            Get
                Return Me.m_criteria
            End Get
        End Property

        <Input> _
        Public Property length As Integer
            Get
                Return Me.m_length
            End Get
            Set(ByVal value As Integer)
                Me.m_length = value
            End Set
        End Property

        <Input> _
        Public Property occur As Double
            Get
                Return Me.m_occur
            End Get
            Set(ByVal value As Double)
                Me.m_occur = value
            End Set
        End Property


        ' Fields
        Private m_countif1 As CountIf
        Private m_criteria As ISeries(Of Boolean)
        Private m_length As Integer
        Private m_occur As Double
        Private Plot1 As IPlotObject
        Private Plot2 As IPlotObject
    End Class
End Namespace

