﻿Imports PowerLanguage
Imports System
Imports System.Drawing

Namespace PowerLanguage.Indicator
    Public Class Custom_ShowMe
        Inherits IndicatorObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
        End Sub

        Protected Overrides Sub CalcBar()
            If Me.criteria.Item(0) Then
                Me.Plot1.Set(0, Me.plotprice.Item(0))
                MyBase.Alerts.Alert
            Else
                Me.Plot1.Reset
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.Plot1 = MyBase.AddPlot(New PlotAttributes("CustomSM", EPlotShapes.Point, Color.Cyan, Color.Empty, 4, 0, True))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_criteria = New Lambda(Of Boolean)(Function(_bb) (PublicFunctions.DoubleLess(MyBase.Bars.High.Item(_bb), MyBase.Bars.High.Item((1 + _bb))) AndAlso PublicFunctions.DoubleGreater(MyBase.Bars.Low.Item(_bb), MyBase.Bars.Low.Item((1 + _bb)))))
            Me.m_plotprice = New Lambda(Of Double)( Function() MyBase.Bars.Close.Item(0))
        End Sub


        ' Properties
        Private ReadOnly Property criteria As ISeries(Of Boolean)
            Get
                Return Me.m_criteria
            End Get
        End Property

        Private ReadOnly Property plotprice As ISeries(Of Double)
            Get
                Return Me.m_plotprice
            End Get
        End Property


        ' Fields
        Private m_criteria As ISeries(Of Boolean)
        Private m_plotprice As ISeries(Of Double)
        Private Plot1 As IPlotObject
    End Class
End Namespace

