﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System
Imports System.Drawing

Namespace PowerLanguage.Indicator
    Public Class DMI
        Inherits IndicatorObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_length = 14
            Me.m_adxtrend = 25
        End Sub

        Protected Overrides Sub CalcBar()
            Me.m_value1 = Me.m_dirmovement1.Item(0)
            Me.Plot1.Set(0, Me.m_odmiplus.Value)
            Me.Plot2.Set(0, Me.m_odmiminus.Value)
            Me.Plot3.Set(0, Me.m_oadx.Value)
            If PublicFunctions.DoubleGreater(Me.m_oadx.Value, Me.adxtrend) Then
                If Me.CrossesOver(Me.m_odmiplus, Me.m_odmiminus) Then
                    MyBase.Alerts.Alert("Bullish alert", New Object(0  - 1) {})
                ElseIf Me.CrossesUnder(Me.m_odmiplus, Me.m_odmiminus) Then
                    MyBase.Alerts.Alert("Bearish alert", New Object(0  - 1) {})
                End If
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_dirmovement1 = New DirMovement(Me)
            Me.m_odmiplus = New VariableSeries(Of Double)(Me)
            Me.m_odmiminus = New VariableSeries(Of Double)(Me)
            Me.m_odmi = New VariableSeries(Of Double)(Me)
            Me.m_oadx = New VariableSeries(Of Double)(Me)
            Me.m_oadxr = New VariableObject(Of Double)(Me)
            Me.m_ovolty = New VariableSeries(Of Double)(Me)
            Me.Plot1 = MyBase.AddPlot(New PlotAttributes("DMI+", EPlotShapes.Line, Color.Yellow, Color.Empty, 0, 0, True))
            Me.Plot2 = MyBase.AddPlot(New PlotAttributes("DMI-", EPlotShapes.Line, Color.Blue, Color.Empty, 0, 0, True))
            Me.Plot3 = MyBase.AddPlot(New PlotAttributes("ADX", EPlotShapes.Line, Color.Cyan, Color.Empty, 0, 0, True))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_dirmovement1.priceh = MyBase.Bars.High
            Me.m_dirmovement1.pricel = MyBase.Bars.Low
            Me.m_dirmovement1.pricec = MyBase.Bars.Close
            Me.m_dirmovement1.length = New Lambda(Of Integer)(Function() Me.length)
            Me.m_dirmovement1.odmiplus = Me.m_odmiplus
            Me.m_dirmovement1.odmiminus = Me.m_odmiminus
            Me.m_dirmovement1.odmi = Me.m_odmi
            Me.m_dirmovement1.oadx = Me.m_oadx
            Me.m_dirmovement1.oadxr = Me.m_oadxr
            Me.m_dirmovement1.ovolty = Me.m_ovolty
            Me.m_value1 = 0
            Me.m_odmiplus.DefaultValue = 0
            Me.m_odmiminus.DefaultValue = 0
            Me.m_odmi.DefaultValue = 0
            Me.m_oadx.DefaultValue = 0
            Me.m_oadxr.DefaultValue = 0
            Me.m_ovolty.DefaultValue = 0
        End Sub


        ' Properties
        <Input()> _
        Public Property adxtrend As Double
            Get
                Return Me.m_adxtrend
            End Get
            Set(ByVal value As Double)
                Me.m_adxtrend = value
            End Set
        End Property

        <Input()> _
        Public Property length As Integer
            Get
                Return Me.m_length
            End Get
            Set(ByVal value As Integer)
                Me.m_length = value
            End Set
        End Property


        ' Fields
        Private m_adxtrend As Double
        Private m_dirmovement1 As DirMovement
        Private m_length As Integer
        Private m_oadx As VariableSeries(Of Double)
        Private m_oadxr As VariableObject(Of Double)
        Private m_odmi As VariableSeries(Of Double)
        Private m_odmiminus As VariableSeries(Of Double)
        Private m_odmiplus As VariableSeries(Of Double)
        Private m_ovolty As VariableSeries(Of Double)
        Private m_value1 As Double
        Private Plot1 As IPlotObject
        Private Plot2 As IPlotObject
        Private Plot3 As IPlotObject
    End Class
End Namespace

