﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System
Imports System.Drawing

Namespace PowerLanguage.Indicator
    Public Class Formula_OHLC
        Inherits IndicatorObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_baseline1 = 70
            Me.m_baseline2 = 30
            Me.m_plotbaseline1 = True
            Me.m_plotbaseline2 = True
        End Sub

        Protected Overrides Sub CalcBar()
            Me.m_formula = Me.m_rsi1.Item(0)
            If MyBase.Environment.IsRealTimeCalc Then
                If (Not Me.m_barnum.Value = MyBase.Bars.CurrentBar) Then
                    Me.m_formulaopen.Value = Me.m_formula
                    Me.m_formulahigh.Value = Me.m_formula
                    Me.m_formulalow.Value = Me.m_formula
                    Me.m_formulaclose = Me.m_formula
                    Me.m_barnum.Value = MyBase.Bars.CurrentBar
                End If
                If PublicFunctions.DoubleGreater(Me.m_formula, Me.m_formulahigh.Value) Then
                    Me.m_formulahigh.Value = Me.m_formula
                End If
                If PublicFunctions.DoubleLess(Me.m_formula, Me.m_formulalow.Value) Then
                    Me.m_formulalow.Value = Me.m_formula
                End If
                Me.Plot1.Set(0, Me.m_formulaopen.Value)
                Me.Plot2.Set(0, Me.m_formulahigh.Value)
                Me.Plot3.Set(0, Me.m_formulalow.Value)
                Me.Plot4.Set(0, Me.m_formula)
            End If
            If Me.plotbaseline1 Then
                Me.Plot5.Set(0, Me.baseline1)
            End If
            If Me.plotbaseline2 Then
                Me.Plot6.Set(0, Me.baseline2)
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_rsi1 = New PowerLanguage.Function.RSI(Me)
            Me.m_barnum = New VariableObject(Of Double)(Me)
            Me.m_formulaopen = New VariableObject(Of Double)(Me)
            Me.m_formulahigh = New VariableObject(Of Double)(Me)
            Me.m_formulalow = New VariableObject(Of Double)(Me)
            Me.Plot1 = MyBase.AddPlot(New PlotAttributes("LambdaOpen", EPlotShapes.LeftTick, Color.Blue, Color.Empty, 0, 0, True))
            Me.Plot2 = MyBase.AddPlot(New PlotAttributes("LambdaHigh", EPlotShapes.BarHigh, Color.Blue, Color.Empty, 0, 0, True))
            Me.Plot3 = MyBase.AddPlot(New PlotAttributes("LambdaLow", EPlotShapes.BarLow, Color.Blue, Color.Empty, 0, 0, True))
            Me.Plot4 = MyBase.AddPlot(New PlotAttributes("LambdaClose", EPlotShapes.RightTick, Color.Blue, Color.Empty, 0, 0, True))
            Me.Plot5 = MyBase.AddPlot(New PlotAttributes("Baseline1", EPlotShapes.Line, Color.Green, Color.Empty, 0, 0, True))
            Me.Plot6 = MyBase.AddPlot(New PlotAttributes("Baseline2", EPlotShapes.Line, Color.Green, Color.Empty, 0, 0, True))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_rsi1.price = MyBase.Bars.Close
            Me.m_rsi1.length = New ConstantObject(Of Integer)(14)
            Me.m_formula = 0
            Me.m_barnum.DefaultValue = 0
            Me.m_formulaopen.DefaultValue = 0
            Me.m_formulahigh.DefaultValue = 0
            Me.m_formulalow.DefaultValue = 0
            Me.m_formulaclose = 0
        End Sub


        ' Properties
        <Input()> _
        Public Property baseline1 As Double
            Get
                Return Me.m_baseline1
            End Get
            Set(ByVal value As Double)
                Me.m_baseline1 = value
            End Set
        End Property

        <Input()> _
        Public Property baseline2 As Double
            Get
                Return Me.m_baseline2
            End Get
            Set(ByVal value As Double)
                Me.m_baseline2 = value
            End Set
        End Property

        <Input()> _
        Public Property plotbaseline1 As Boolean
            Get
                Return Me.m_plotbaseline1
            End Get
            Set(ByVal value As Boolean)
                Me.m_plotbaseline1 = value
            End Set
        End Property

        <Input()> _
        Public Property plotbaseline2 As Boolean
            Get
                Return Me.m_plotbaseline2
            End Get
            Set(ByVal value As Boolean)
                Me.m_plotbaseline2 = value
            End Set
        End Property


        ' Fields
        Private m_barnum As VariableObject(Of Double)
        Private m_baseline1 As Double
        Private m_baseline2 As Double
        Private m_formula As Double
        Private m_formulaclose As Double
        Private m_formulahigh As VariableObject(Of Double)
        Private m_formulalow As VariableObject(Of Double)
        Private m_formulaopen As VariableObject(Of Double)
        Private m_plotbaseline1 As Boolean
        Private m_plotbaseline2 As Boolean
        Private m_rsi1 As PowerLanguage.Function.RSI
        Private Plot1 As IPlotObject
        Private Plot2 As IPlotObject
        Private Plot3 As IPlotObject
        Private Plot4 As IPlotObject
        Private Plot5 As IPlotObject
        Private Plot6 As IPlotObject
    End Class
End Namespace

