﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System
Imports System.Drawing
Imports System.Runtime.CompilerServices

Namespace PowerLanguage.Indicator
    <SameAsSymbol(True)> _
    Public Class Keltner_Channel
        Inherits IndicatorObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_length = 20
            Me.m_numatrs = 1.5
        End Sub

        Protected Overrides Sub CalcBar()
            Me.m_avg = Me.m_averagefc1.Item(0)
            Me.m_shift = (Me.numatrs * Me.m_avgtruerange1.Item(0))
            Me.m_upperband.Value = (Me.m_avg + Me.m_shift)
            Me.m_lowerband.Value = (Me.m_avg - Me.m_shift)
            If ((Me.displace >= 0) OrElse (MyBase.Bars.CurrentBar > Math.Abs(Me.displace))) Then
                Me.Plot1.Set(Me.displace, Me.m_upperband.Value)
                Me.Plot2.Set(Me.displace, Me.m_lowerband.Value)
                Me.Plot3.Set(Me.displace, Me.m_avg)
                If (Me.displace <= 0) Then
                    If Me.CrossesOver(Me.price, Me.m_upperband) Then
                        MyBase.Alerts.Alert("Price crossing over upper band", New Object(0  - 1) {})
                    ElseIf Me.CrossesUnder(Me.price, Me.m_lowerband) Then
                        MyBase.Alerts.Alert("Price crossing under lower band", New Object(0  - 1) {})
                    End If
                End If
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_averagefc1 = New AverageFC(Me)
            Me.m_avgtruerange1 = New AvgTrueRange(Me)
            Me.m_lowerband = New VariableSeries(Of Double)(Me)
            Me.m_upperband = New VariableSeries(Of Double)(Me)
            Me.Plot1 = MyBase.AddPlot(New PlotAttributes("UpperBand", EPlotShapes.Line, Color.Yellow, Color.Empty, 0, 0, True))
            Me.Plot2 = MyBase.AddPlot(New PlotAttributes("LowerBand", EPlotShapes.Line, Color.Blue, Color.Empty, 0, 0, True))
            Me.Plot3 = MyBase.AddPlot(New PlotAttributes("MidLine", EPlotShapes.Line, Color.Gray, Color.Empty, 0, 0, True))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_price = MyBase.Bars.Close
            Me.m_averagefc1.price = Me.price
            Me.m_averagefc1.length = New Lambda(Of Integer)( Function() Me.length)
            Me.m_avgtruerange1.length = New Lambda(Of Integer)( Function() Me.length)
            Me.m_avg = 0
            Me.m_shift = 0
            Me.m_lowerband.DefaultValue = 0
            Me.m_upperband.DefaultValue = 0
        End Sub


        ' Properties
        Private m_displace As Integer
        <Input()> _
        Public Property displace As Integer
            Set (ByVal value As Integer)
                m_displace = value
            End Set
            Get
                Return Me.m_displace
            End Get
        End Property
        <Input> _
        Public Property length As Integer
            Get
                Return Me.m_length
            End Get
            Set(ByVal value As Integer)
                Me.m_length = value
            End Set
        End Property

        <Input()> _
        Public Property numatrs As Double
            Get
                Return Me.m_numatrs
            End Get
            Set(ByVal value As Double)
                Me.m_numatrs = value
            End Set
        End Property

        Private ReadOnly Property price As ISeries(Of Double)
            Get
                Return Me.m_price
            End Get
        End Property


        ' Fields
        Private m_averagefc1 As AverageFC
        Private m_avg As Double
        Private m_avgtruerange1 As AvgTrueRange
        Private m_length As Integer
        Private m_lowerband As VariableSeries(Of Double)
        Private m_numatrs As Double
        Private m_price As ISeries(Of Double)
        Private m_shift As Double
        Private m_upperband As VariableSeries(Of Double)
        Private Plot1 As IPlotObject
        Private Plot2 As IPlotObject
        Private Plot3 As IPlotObject
    End Class
End Namespace

