﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System
Imports System.Drawing

Namespace PowerLanguage.Indicator
    Public Class MACD
        Inherits IndicatorObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_fastlength = 12
            Me.m_slowlength = &H1A
            Me.m_macdlength = 9
        End Sub

        Protected Overrides Sub CalcBar()
            Me.m_mymacd.Value = Me.m_macd1.Item(0)
            Me.m_macdavg = Me.m_xaverage1.Item(0)
            Me.m_macddiff.Value = (Me.m_mymacd.Value - Me.m_macdavg)
            Me.Plot1.Set(0, Me.m_mymacd.Value)
            Me.Plot2.Set(0, Me.m_macdavg)
            Me.Plot3.Set(0, Me.m_macddiff.Value)
            Me.Plot4.Set(0, 0)
            If DirectCast(Me, IStudy).CrossesOver(DirectCast(Me.m_macddiff, ISeries(Of Double)), CDbl(0)) Then
                MyBase.Alerts.Alert("Bullish alert", New Object(0 - 1) {})
            ElseIf DirectCast(Me, IStudy).CrossesUnder(DirectCast(Me.m_macddiff, ISeries(Of Double)), CDbl(0)) Then
                MyBase.Alerts.Alert("Bearish alert", New Object(0 - 1) {})
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_macd1 = New PowerLanguage.Function.MACD(Me)
            Me.m_xaverage1 = New XAverage(Me)
            Me.m_mymacd = New VariableSeries(Of Double)(Me)
            Me.m_macddiff = New VariableSeries(Of Double)(Me)
            Me.Plot1 = MyBase.AddPlot(New PlotAttributes("MACD", EPlotShapes.Line, Color.Cyan, Color.Empty, 0, 0, True))
            Me.Plot2 = MyBase.AddPlot(New PlotAttributes("MACDAvg", EPlotShapes.Line, Color.Yellow, Color.Empty, 0, 0, True))
            Me.Plot3 = MyBase.AddPlot(New PlotAttributes("MACDDiff", EPlotShapes.Histogram, Color.Blue, Color.Empty, 0, 0, True))
            Me.Plot4 = MyBase.AddPlot(New PlotAttributes("ZeroLine", EPlotShapes.Line, Color.Green, Color.Empty, 0, 0, True))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_macd1.Price = MyBase.Bars.Close
            Me.m_macd1.FastLength = Me.fastlength
            Me.m_macd1.SlowLength = Me.slowlength
            Me.m_xaverage1.Price = Me.m_mymacd
            Me.m_xaverage1.Length = Me.macdlength
            Me.m_mymacd.DefaultValue = 0
            Me.m_macdavg = 0
            Me.m_macddiff.DefaultValue = 0
        End Sub


        ' Properties
        <Input()> _
        Public Property fastlength As Integer
            Get
                Return Me.m_fastlength
            End Get
            Set(ByVal value As Integer)
                Me.m_fastlength = value
            End Set
        End Property

        <Input()> _
        Public Property macdlength As Integer
            Get
                Return Me.m_macdlength
            End Get
            Set(ByVal value As Integer)
                Me.m_macdlength = value
            End Set
        End Property

        <Input()> _
        Public Property slowlength As Integer
            Get
                Return Me.m_slowlength
            End Get
            Set(ByVal value As Integer)
                Me.m_slowlength = value
            End Set
        End Property


        ' Fields
        Private m_fastlength As Integer
        Private m_macd1 As PowerLanguage.Function.MACD
        Private m_macdavg As Double
        Private m_macddiff As VariableSeries(Of Double)
        Private m_macdlength As Integer
        Private m_mymacd As VariableSeries(Of Double)
        Private m_slowlength As Integer
        Private m_xaverage1 As XAverage
        Private Plot1 As IPlotObject
        Private Plot2 As IPlotObject
        Private Plot3 As IPlotObject
        Private Plot4 As IPlotObject
    End Class
End Namespace

