﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System
Imports System.Drawing

Namespace PowerLanguage.Indicator
    <SameAsSymbol(True)> _
    Public Class MACD_Gradient
        Inherits IndicatorObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_fastlength = 12
            Me.m_slowlength = &H1A
            Me.m_macdlength = 9
            Me.m_colornormlength = 14
            Me.m_upcolor = Color.Yellow
            Me.m_dncolor = Color.Magenta
        End Sub

        Protected Overrides Sub CalcBar()
            Me.m_macdvalue.Value = Me.m_macd1.Item(0)
            Me.m_macdavg = Me.m_xaverage1.Item(0)
            Me.m_macddiff.Value = (Me.m_macdvalue.Value - Me.m_macdavg)
            Me.m_colorlevel = Me.m_normgradientcolor1.Item(0)
            Me.Plot1.Set(0, MyBase.Bars.High.Item(0), Me.m_colorlevel)
            Me.Plot2.Set(0, MyBase.Bars.Low.Item(0), Me.m_colorlevel)
            Me.Plot3.Set(0, MyBase.Bars.Open.Item(0), Me.m_colorlevel)
            Me.Plot4.Set(0, MyBase.Bars.Close.Item(0), Me.m_colorlevel)
        End Sub

        Protected Overrides Sub Create()
            Me.m_macd1 = New PowerLanguage.Function.MACD(Me)
            Me.m_xaverage1 = New XAverage(Me)
            Me.m_normgradientcolor1 = New NormGradientColor(Me)
            Me.m_macdvalue = New VariableSeries(Of Double)(Me)
            Me.m_macddiff = New VariableSeries(Of Double)(Me)
            Me.Plot1 = MyBase.AddPlot(New PlotAttributes("Plot1", EPlotShapes.BarHigh, Color.White, Color.Empty, 0, 0, True))
            Me.Plot2 = MyBase.AddPlot(New PlotAttributes("Plot2", EPlotShapes.BarLow, Color.White, Color.Empty, 0, 0, True))
            Me.Plot3 = MyBase.AddPlot(New PlotAttributes("Plot3", EPlotShapes.LeftTick, Color.White, Color.Empty, 0, 0, True))
            Me.Plot4 = MyBase.AddPlot(New PlotAttributes("Plot4", EPlotShapes.RightTick, Color.White, Color.Empty, 0, 0, True))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_macd1.Price = MyBase.Bars.Close
            Me.m_macd1.FastLength = Me.fastlength
            Me.m_macd1.SlowLength = Me.slowlength
            Me.m_xaverage1.Price = Me.m_macdvalue
            Me.m_xaverage1.Length = Me.macdlength
            Me.m_normgradientcolor1.dataseriesvalue = Me.m_macddiff
            Me.m_normgradientcolor1.crosseszero = New ConstantObject(Of Boolean)(True)
            Me.m_normgradientcolor1.colornormlength = New Lambda(Of Integer)( Function() Me.colornormlength)
            Me.m_normgradientcolor1.upcolor = New Lambda(Of Color)( Function() Me.m_upcolor)
            Me.m_normgradientcolor1.dncolor = New Lambda(Of Color)( Function() Me.m_dncolor)
            Me.m_macdvalue.DefaultValue = 0
            Me.m_macdavg = 0
            Me.m_macddiff.DefaultValue = 0
            Me.m_colorlevel = Color.Empty
        End Sub


        ' Properties
        <Input()> _
        Public Property colornormlength As Integer
            Get
                Return Me.m_colornormlength
            End Get
            Set(ByVal value As Integer)
                Me.m_colornormlength = value
            End Set
        End Property

        <Input()> _
        Public Property dncolor As KnownColor
            Get
                Return Me.m_dncolor.ToKnownColor
            End Get
            Set(ByVal value As KnownColor)
                Me.m_dncolor = Color.FromKnownColor(value)
            End Set
        End Property

        <Input()> _
        Public Property fastlength As Integer
            Get
                Return Me.m_fastlength
            End Get
            Set(ByVal value As Integer)
                Me.m_fastlength = value
            End Set
        End Property

        <Input()> _
        Public Property macdlength As Integer
            Get
                Return Me.m_macdlength
            End Get
            Set(ByVal value As Integer)
                Me.m_macdlength = value
            End Set
        End Property

        <Input()> _
        Public Property slowlength As Integer
            Get
                Return Me.m_slowlength
            End Get
            Set(ByVal value As Integer)
                Me.m_slowlength = value
            End Set
        End Property

        <Input()> _
        Public Property upcolor As KnownColor
            Get
                Return Me.m_upcolor.ToKnownColor
            End Get
            Set(ByVal value As KnownColor)
                Me.m_upcolor = Color.FromKnownColor(value)
            End Set
        End Property


        ' Fields
        Private m_colorlevel As Color
        Private m_colornormlength As Integer
        Private m_dncolor As Color
        Private m_fastlength As Integer
        Private m_macd1 As PowerLanguage.Function.MACD
        Private m_macdavg As Double
        Private m_macddiff As VariableSeries(Of Double)
        Private m_macdlength As Integer
        Private m_macdvalue As VariableSeries(Of Double)
        Private m_normgradientcolor1 As NormGradientColor
        Private m_slowlength As Integer
        Private m_upcolor As Color
        Private m_xaverage1 As XAverage
        Private Plot1 As IPlotObject
        Private Plot2 As IPlotObject
        Private Plot3 As IPlotObject
        Private Plot4 As IPlotObject
    End Class
End Namespace

