﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System
Imports System.Drawing

Namespace PowerLanguage.Indicator
    Public Class McClellan_Osc
        Inherits IndicatorObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_fastlength = &H13
            Me.m_slowlength = &H27
            Me.m_oversold = -70
            Me.m_overbought = 70
        End Sub

        Protected Overrides Sub CalcBar()
            Me.m_mcclosc.Value = Me.m_mcclellanosc1.Item(0)
            Me.Plot1.Set(0, Me.m_mcclosc.Value)
            Me.Plot2.Set(0, Me.overbought)
            Me.Plot3.Set(0, Me.oversold)
            If Me.CrossesOver(Me.m_mcclosc, New Lambda(Of Double)( Function() Me.oversold)) Then
                MyBase.Alerts.Alert("Indicator exiting oversold zone", New Object(0 - 1) {})
            ElseIf Me.CrossesUnder(Me.m_mcclosc, New Lambda(Of Double)( Function() Me.overbought)) Then
                MyBase.Alerts.Alert("Indicator exiting overbought zone", New Object(0 - 1) {})
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_mcclellanosc1 = New McClellanOsc(Me)
            Me.m_mcclosc = New VariableSeries(Of Double)(Me)
            Me.Plot1 = MyBase.AddPlot(New PlotAttributes("McClOsc", EPlotShapes.Line, Color.Blue, Color.Empty, 0, 0, True))
            Me.Plot2 = MyBase.AddPlot(New PlotAttributes("OverBot", EPlotShapes.Line, Color.Green, Color.Empty, 0, 0, True))
            Me.Plot3 = MyBase.AddPlot(New PlotAttributes("OverSld", EPlotShapes.Line, Color.Green, Color.Empty, 0, 0, True))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_advissues = MyBase.Bars.Close
            Me.m_decissues = MyBase.BarsOfData(2).Close
            Me.m_mcclellanosc1.advissues = Me.advissues
            Me.m_mcclellanosc1.decissues = Me.decissues
            Me.m_mcclellanosc1.fastlength = Me.fastlength
            Me.m_mcclellanosc1.slowlength = Me.slowlength
            Me.m_mcclosc.DefaultValue = 0
        End Sub


        ' Properties
        Private ReadOnly Property advissues As ISeries(Of Double)
            Get
                Return Me.m_advissues
            End Get
        End Property

        Private ReadOnly Property decissues As ISeries(Of Double)
            Get
                Return Me.m_decissues
            End Get
        End Property

        <Input()> _
        Public Property fastlength As Integer
            Get
                Return Me.m_fastlength
            End Get
            Set(ByVal value As Integer)
                Me.m_fastlength = value
            End Set
        End Property

        <Input()> _
        Public Property overbought As Double
            Get
                Return Me.m_overbought
            End Get
            Set(ByVal value As Double)
                Me.m_overbought = value
            End Set
        End Property

        <Input()> _
        Public Property oversold As Double
            Get
                Return Me.m_oversold
            End Get
            Set(ByVal value As Double)
                Me.m_oversold = value
            End Set
        End Property

        <Input()> _
        Public Property slowlength As Integer
            Get
                Return Me.m_slowlength
            End Get
            Set(ByVal value As Integer)
                Me.m_slowlength = value
            End Set
        End Property


        ' Fields
        Private m_advissues As ISeries(Of Double)
        Private m_decissues As ISeries(Of Double)
        Private m_fastlength As Integer
        Private m_mcclellanosc1 As McClellanOsc
        Private m_mcclosc As VariableSeries(Of Double)
        Private m_overbought As Double
        Private m_oversold As Double
        Private m_slowlength As Integer
        Private Plot1 As IPlotObject
        Private Plot2 As IPlotObject
        Private Plot3 As IPlotObject
    End Class
End Namespace

