﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System
Imports System.Drawing

Namespace PowerLanguage.Indicator
    Public Class Mkt_Facilitation_Idx
        Inherits IndicatorObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_alertlength = 14
        End Sub

        Protected Overrides Sub CalcBar()
            Dim resolution As EResolution = MyBase.Bars.Info.Resolution.Type
            If ((((EResolution.Day = resolution) OrElse (EResolution.Week = resolution)) OrElse ((EResolution.Month = resolution) OrElse (EResolution.Quarter = resolution))) OrElse (EResolution.Year = resolution)) Then
                Me.m_anyvol.Value = MyBase.Bars.Volume.Item(0)
            Else
                Me.m_anyvol.Value = MyBase.Bars.Ticks.Item(0)
            End If
            Me.m_mktfacilx.Value = Me.m_mfi1.Item(0)
            Me.Plot1.Set(0, Me.m_mktfacilx.Value)
            If (Me.m_highestbar1.Item(0) = 0) Then
                MyBase.Alerts.Alert("Indicator at high", New Object(0  - 1) {})
            ElseIf (Me.m_lowestbar1.Item(0) = 0) Then
                MyBase.Alerts.Alert("Indicator at low", New Object(0  - 1) {})
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_mfi1 = New MFI(Me)
            Me.m_highestbar1 = New HighestBar(Me)
            Me.m_lowestbar1 = New LowestBar(Me)
            Me.m_mktfacilx = New VariableSeries(Of Double)(Me)
            Me.m_anyvol = New VariableSeries(Of Double)(Me)
            Me.Plot1 = MyBase.AddPlot(New PlotAttributes("MktFacilX", EPlotShapes.Line, Color.Blue, Color.Empty, 0, 0, True))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_mfi1.anyvol = Me.m_anyvol
            Me.m_highestbar1.price = Me.m_mktfacilx
            Me.m_highestbar1.length = New Lambda(Of Integer)( Function() Me.alertlength)
            Me.m_lowestbar1.price = Me.m_mktfacilx
            Me.m_lowestbar1.length = New Lambda(Of Integer)( Function() Me.alertlength)
            Me.m_mktfacilx.DefaultValue = 0
            Me.m_anyvol.DefaultValue = 0
        End Sub


        ' Properties
        <Input()> _
        Public Property alertlength As Integer
            Get
                Return Me.m_alertlength
            End Get
            Set(ByVal value As Integer)
                Me.m_alertlength = value
            End Set
        End Property


        ' Fields
        Private m_alertlength As Integer
        Private m_anyvol As VariableSeries(Of Double)
        Private m_highestbar1 As HighestBar
        Private m_lowestbar1 As LowestBar
        Private m_mfi1 As MFI
        Private m_mktfacilx As VariableSeries(Of Double)
        Private Plot1 As IPlotObject
    End Class
End Namespace

