﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System
Imports System.Drawing

Namespace PowerLanguage.Indicator
    Public Class Momentum
        Inherits IndicatorObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_length = 12
            Me.m_colornormlength = 14
            Me.m_upcolor = Color.Yellow
            Me.m_dncolor = Color.Red
            Me.m_gridforegroundcolor = Color.FromKnownColor(KnownColor.Black)
        End Sub

        Protected Overrides Sub CalcBar()
            If (MyBase.Bars.CurrentBar = 1) Then
                Me.m_applicationtype.Value = DirectCast(MyBase.Environment.ApplicationCode, Integer)
            End If
            Me.m_mom.Value = Me.m_momentum1.Item(0)
            Me.m_accel = Me.m_momentum2.Item(0)
            Me.Plot1.Set(0, Me.m_mom.Value)
            Me.Plot2.Set(0, 0)
            Me.m_colorlevel = Me.m_normgradientcolor1.Item(0)
            If (Me.m_applicationtype.Value = 1) Then
                Me.Plot1.Colors.Item(0) = Me.m_colorlevel
            ElseIf (Me.m_applicationtype.Value > 1) Then
                Me.Plot1.Colors.Item(0) = Me.m_gridforegroundcolor
                Me.Plot1.BGColor = Me.m_colorlevel
            End If
            If (PublicFunctions.DoubleGreater(Me.m_mom.Value, 0) AndAlso PublicFunctions.DoubleGreater(Me.m_accel, 0)) Then
                MyBase.Alerts.Alert("Indicator positive and increasing", New Object(0  - 1) {})
            ElseIf (PublicFunctions.DoubleLess(Me.m_mom.Value, 0) AndAlso PublicFunctions.DoubleLess(Me.m_accel, 0)) Then
                MyBase.Alerts.Alert("Indicator negative and decreasing", New Object(0  - 1) {})
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_momentum1 = New PowerLanguage.Function.Momentum(Me)
            Me.m_momentum2 = New PowerLanguage.Function.Momentum(Me)
            Me.m_normgradientcolor1 = New NormGradientColor(Me)
            Me.m_applicationtype = New VariableObject(Of Integer)(Me)
            Me.m_mom = New VariableSeries(Of Double)(Me)
            Me.Plot1 = MyBase.AddPlot(New PlotAttributes("Momentum", EPlotShapes.Line, Color.Blue, Color.Empty, 0, 0, True))
            Me.Plot2 = MyBase.AddPlot(New PlotAttributes("ZeroLine", EPlotShapes.Line, Color.Green, Color.Empty, 0, 0, True))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_price = MyBase.Bars.Close
            Me.m_momentum1.price = Me.price
            Me.m_momentum1.length = New Lambda(Of Integer)( Function() Me.length)
            Me.m_momentum2.price = Me.m_mom
            Me.m_momentum2.length = New ConstantObject(Of Integer)(1)
            Me.m_normgradientcolor1.dataseriesvalue = Me.m_mom
            Me.m_normgradientcolor1.crosseszero = New ConstantObject(Of Boolean)(True)
            Me.m_normgradientcolor1.colornormlength = New Lambda(Of Integer)( Function() Me.colornormlength)
            Me.m_normgradientcolor1.upcolor = New Lambda(Of Color)(Function() Me.m_upcolor)
            Me.m_normgradientcolor1.dncolor = New Lambda(Of Color)(Function() Me.m_dncolor)
            Me.m_applicationtype.DefaultValue = 0
            Me.m_mom.DefaultValue = 0
            Me.m_accel = 0
            Me.m_colorlevel = Color.Empty
        End Sub


        ' Properties
        <Input()> _
        Public Property colornormlength As Integer
            Get
                Return Me.m_colornormlength
            End Get
            Set(ByVal value As Integer)
                Me.m_colornormlength = value
            End Set
        End Property

        <Input()> _
        Public Property dncolor As KnownColor
            Get
                Return Me.m_dncolor.ToKnownColor
            End Get
            Set(ByVal value As KnownColor)
                Me.m_dncolor = Color.FromKnownColor(value)
            End Set
        End Property

        <Input()> _
        Public Property gridforegroundcolor As KnownColor
            Get
                Return Me.m_gridforegroundcolor.ToKnownColor
            End Get
            Set(ByVal value As KnownColor)
                Me.m_gridforegroundcolor = Color.FromKnownColor(value)
            End Set
        End Property

        <Input()> _
        Public Property length As Integer
            Get
                Return Me.m_length
            End Get
            Set(ByVal value As Integer)
                Me.m_length = value
            End Set
        End Property

        Private ReadOnly Property price As ISeries(Of Double)
            Get
                Return Me.m_price
            End Get
        End Property

        <Input()> _
        Public Property upcolor As KnownColor
            Get
                Return Me.m_upcolor.ToKnownColor
            End Get
            Set(ByVal value As KnownColor)
                Me.m_upcolor = Color.FromKnownColor(value)
            End Set
        End Property


        ' Fields
        Private m_accel As Double
        Private m_applicationtype As VariableObject(Of Integer)
        Private m_colorlevel As Color
        Private m_colornormlength As Integer
        Private m_dncolor As Color
        Private m_gridforegroundcolor As Color
        Private m_length As Integer
        Private m_mom As VariableSeries(Of Double)
        Private m_momentum1 As PowerLanguage.Function.Momentum
        Private m_momentum2 As PowerLanguage.Function.Momentum
        Private m_normgradientcolor1 As NormGradientColor
        Private m_price As ISeries(Of Double)
        Private m_upcolor As Color
        Private Plot1 As IPlotObject
        Private Plot2 As IPlotObject
    End Class
End Namespace

