﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System
Imports System.Drawing

Namespace PowerLanguage.Indicator
    <SameAsSymbol(True)> _
    Public Class Momentum_Decreasing
        Inherits IndicatorObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_momlength = 14
            Me.m_momavglength = 14
        End Sub

        Protected Overrides Sub CalcBar()
            Me.m_momavg.Value = PublicFunctions.Average(Me.m_momentum1, Me.momavglength)
            If PublicFunctions.DoubleLess(Me.m_momavg.Value, Me.m_momavg.Item(1)) Then
                Me.Plot1.Set(0, MyBase.Bars.High.Item(0))
                Me.Plot2.Set(0, MyBase.Bars.Low.Item(0))
                MyBase.Alerts.Alert
            Else
                Me.Plot1.Reset
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_momentum1 = New PowerLanguage.Function.Momentum(Me)
            Me.m_momavg = New VariableSeries(Of Double)(Me)
            Me.Plot1 = MyBase.AddPlot(New PlotAttributes("Plot1", EPlotShapes.BarHigh, Color.Red, Color.Empty, 0, 0, True))
            Me.Plot2 = MyBase.AddPlot(New PlotAttributes("Plot2", EPlotShapes.BarLow, Color.Red, Color.Empty, 0, 0, True))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_price = MyBase.Bars.Close
            Me.m_momentum1.price = MyBase.Bars.Close
            Me.m_momentum1.length = New Lambda(Of Integer)( Function() Me.momlength)
            Me.m_momavg.DefaultValue = 0
        End Sub


        ' Properties
        <Input()> _
        Public Property momavglength As Integer
            Get
                Return Me.m_momavglength
            End Get
            Set(ByVal value As Integer)
                Me.m_momavglength = value
            End Set
        End Property

        <Input()> _
        Public Property momlength As Integer
            Get
                Return Me.m_momlength
            End Get
            Set(ByVal value As Integer)
                Me.m_momlength = value
            End Set
        End Property

        Private ReadOnly Property price As ISeries(Of Double)
            Get
                Return Me.m_price
            End Get
        End Property


        ' Fields
        Private m_momavg As VariableSeries(Of Double)
        Private m_momavglength As Integer
        Private m_momentum1 As PowerLanguage.Function.Momentum
        Private m_momlength As Integer
        Private m_price As ISeries(Of Double)
        Private Plot1 As IPlotObject
        Private Plot2 As IPlotObject
    End Class
End Namespace

