﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System
Imports System.Drawing

Namespace PowerLanguage.Indicator
    <SameAsSymbol(True)> _
    Public Class Mov_Avg_Adaptive
        Inherits IndicatorObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_effratiolength = 10
            Me.m_fastavglength = 2
            Me.m_slowavglength = 30
        End Sub

        Protected Overrides Sub CalcBar()
            Me.m_maa.Value = Me.m_adaptivemovavg1.Item(0)
            Me.Plot1.Set(0, Me.m_maa.Value)
            If Me.CrossesOver(Me.price, Me.m_maa) Then
                MyBase.Alerts.Alert("Bullish alert", New Object(0  - 1) {})
            ElseIf Me.CrossesUnder(Me.price, Me.m_maa) Then
                MyBase.Alerts.Alert("Bearish alert", New Object(0  - 1) {})
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_adaptivemovavg1 = New AdaptiveMovAvg(Me)
            Me.m_maa = New VariableSeries(Of Double)(Me)
            Me.Plot1 = MyBase.AddPlot(New PlotAttributes("MAA", EPlotShapes.Line, Color.Cyan, Color.Empty, 0, 0, True))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_price = MyBase.Bars.Close
            Me.m_adaptivemovavg1.price = Me.price
            Me.m_adaptivemovavg1.effratiolength = New Lambda(Of Integer)( Function() Me.effratiolength)
            Me.m_adaptivemovavg1.fastavglength = New Lambda(Of Integer)( Function() Me.fastavglength)
            Me.m_adaptivemovavg1.slowavglength = New Lambda(Of Integer)( Function() Me.slowavglength)
            Me.m_maa.DefaultValue = 0
        End Sub


        ' Properties
        <Input()> _
        Public Property effratiolength As Integer
            Get
                Return Me.m_effratiolength
            End Get
            Set(ByVal value As Integer)
                Me.m_effratiolength = value
            End Set
        End Property

        <Input()> _
        Public Property fastavglength As Integer
            Get
                Return Me.m_fastavglength
            End Get
            Set(ByVal value As Integer)
                Me.m_fastavglength = value
            End Set
        End Property

        Private ReadOnly Property price As ISeries(Of Double)
            Get
                Return Me.m_price
            End Get
        End Property

        <Input()> _
        Public Property slowavglength As Integer
            Get
                Return Me.m_slowavglength
            End Get
            Set(ByVal value As Integer)
                Me.m_slowavglength = value
            End Set
        End Property


        ' Fields
        Private m_adaptivemovavg1 As AdaptiveMovAvg
        Private m_effratiolength As Integer
        Private m_fastavglength As Integer
        Private m_maa As VariableSeries(Of Double)
        Private m_price As ISeries(Of Double)
        Private m_slowavglength As Integer
        Private Plot1 As IPlotObject
    End Class
End Namespace

