﻿Imports PowerLanguage
Imports System
Imports System.Drawing

Namespace PowerLanguage.Indicator
    <SameAsSymbol(True)> _
    Public Class Mov_Avg_Crossover
        Inherits IndicatorObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_fastlength = 7
            Me.m_slowlength = 14
            Me.m_upcolor = Color.Cyan
            Me.m_dncolor = Color.FromKnownColor(KnownColor.Blue)
        End Sub

        Protected Overrides Sub CalcBar()
            Me.m_fastavg = PublicFunctions.Average(Me.price, Me.fastlength)
            Me.m_slowavg = PublicFunctions.Average(Me.price, Me.slowlength)
            If PublicFunctions.DoubleGreater(Me.m_fastavg, Me.m_slowavg) Then
                Me.Plot1.Set(0, MyBase.Bars.High.Item(0), Me.m_upcolor)
                Me.Plot2.Set(0, MyBase.Bars.Low.Item(0), Me.m_upcolor)
                MyBase.Alerts.Alert("FastAvg above SlowAvg", New Object(0  - 1) {})
            ElseIf PublicFunctions.DoubleLess(Me.m_fastavg, Me.m_slowavg) Then
                Me.Plot1.Set(0, MyBase.Bars.High.Item(0), Me.m_dncolor)
                Me.Plot2.Set(0, MyBase.Bars.Low.Item(0), Me.m_dncolor)
                MyBase.Alerts.Alert("FastAvg below SlowAvg", New Object(0  - 1) {})
            Else
                Me.Plot1.Reset
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.Plot1 = MyBase.AddPlot(New PlotAttributes("Plot1", EPlotShapes.BarHigh, Color.White, Color.Empty, 0, 0, True))
            Me.Plot2 = MyBase.AddPlot(New PlotAttributes("Plot2", EPlotShapes.BarLow, Color.White, Color.Empty, 0, 0, True))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_price = MyBase.Bars.Close
            Me.m_fastavg = 0
            Me.m_slowavg = 0
        End Sub


        ' Properties
        <Input> _
        Public Property dncolor As KnownColor
            Get
                Return Me.m_dncolor.ToKnownColor
            End Get
            Set(ByVal value As KnownColor)
                Me.m_dncolor = Color.FromKnownColor(value)
            End Set
        End Property

        <Input> _
        Public Property fastlength As Integer
            Get
                Return Me.m_fastlength
            End Get
            Set(ByVal value As Integer)
                Me.m_fastlength = value
            End Set
        End Property

        Private ReadOnly Property price As ISeries(Of Double)
            Get
                Return Me.m_price
            End Get
        End Property

        <Input()> _
        Public Property slowlength As Integer
            Get
                Return Me.m_slowlength
            End Get
            Set(ByVal value As Integer)
                Me.m_slowlength = value
            End Set
        End Property

        <Input()> _
        Public Property upcolor As KnownColor
            Get
                Return Me.m_upcolor.ToKnownColor
            End Get
            Set(ByVal value As KnownColor)
                Me.m_upcolor = Color.FromKnownColor(value)
            End Set
        End Property


        ' Fields
        Private m_dncolor As Color
        Private m_fastavg As Double
        Private m_fastlength As Integer
        Private m_price As ISeries(Of Double)
        Private m_slowavg As Double
        Private m_slowlength As Integer
        Private m_upcolor As Color
        Private Plot1 As IPlotObject
        Private Plot2 As IPlotObject
    End Class
End Namespace

