﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System
Imports System.Drawing

Namespace PowerLanguage.Indicator
    Public Class On_Balance_Volume
        Inherits IndicatorObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_alertlength = 14
        End Sub

        Protected Overrides Sub CalcBar()
            Me.m_obvvalue.Value = Me.m_obv1.Item(0)
            Me.Plot1.Set(0, Me.m_obvvalue.Value)
            If ((Me.m_lowestbar1.Item(0) = 0) AndAlso PublicFunctions.DoubleGreater(Me.m_lowestbar2.Item(0), 0)) Then
                MyBase.Alerts.Alert("Bullish divergence - new low not confirmed", New Object(0  - 1) {})
            ElseIf ((Me.m_highestbar1.Item(0) = 0) AndAlso PublicFunctions.DoubleGreater(Me.m_highestbar2.Item(0), 0)) Then
                MyBase.Alerts.Alert("Bearish divergence - new high not confirmed", New Object(0  - 1) {})
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_obv1 = New OBV(Me)
            Me.m_lowestbar1 = New LowestBar(Me)
            Me.m_lowestbar2 = New LowestBar(Me)
            Me.m_highestbar1 = New HighestBar(Me)
            Me.m_highestbar2 = New HighestBar(Me)
            Me.m_obvvalue = New VariableSeries(Of Double)(Me)
            Me.Plot1 = MyBase.AddPlot(New PlotAttributes("OBV", EPlotShapes.Line, Color.Cyan, Color.Empty, 0, 0, True))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_lowestbar1.price = MyBase.Bars.Close
            Me.m_lowestbar1.length = New Lambda(Of Integer)( Function() Me.alertlength)
            Me.m_lowestbar2.price = Me.m_obvvalue
            Me.m_lowestbar2.length = New Lambda(Of Integer)( Function() Me.alertlength)
            Me.m_highestbar1.price = MyBase.Bars.Close
            Me.m_highestbar1.length = New Lambda(Of Integer)( Function() Me.alertlength)
            Me.m_highestbar2.price = Me.m_obvvalue
            Me.m_highestbar2.length = New Lambda(Of Integer)( Function() Me.alertlength)
            Me.m_obvvalue.DefaultValue = 0
        End Sub


        ' Properties
        <Input()> _
        Public Property alertlength As Integer
            Get
                Return Me.m_alertlength
            End Get
            Set(ByVal value As Integer)
                Me.m_alertlength = value
            End Set
        End Property


        ' Fields
        Private m_alertlength As Integer
        Private m_highestbar1 As HighestBar
        Private m_highestbar2 As HighestBar
        Private m_lowestbar1 As LowestBar
        Private m_lowestbar2 As LowestBar
        Private m_obv1 As OBV
        Private m_obvvalue As VariableSeries(Of Double)
        Private Plot1 As IPlotObject
    End Class
End Namespace

