﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System
Imports System.Drawing

Namespace PowerLanguage.Indicator
    Public Class PcntR
        Inherits IndicatorObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_length = 14
            Me.m_oversold = 20
            Me.m_overbought = 80
            Me.m_overscolor = Color.Cyan
            Me.m_overbcolor = Color.Red
        End Sub

        Protected Overrides Sub CalcBar()
            Me.m_pctr.Value = Me.m_percentr1.Item(0)
            Me.Plot1.Set(0, Me.m_pctr.Value)
            Me.Plot2.Set(0, Me.overbought)
            Me.Plot3.Set(0, Me.oversold)
            If PublicFunctions.DoubleGreater(Me.m_pctr.Value, Me.overbought) Then
                Me.Plot1.Colors.Item(0) = Me.m_overbcolor
            ElseIf PublicFunctions.DoubleLess(Me.m_pctr.Value, Me.oversold) Then
                Me.Plot1.Colors.Item(0) = Me.m_overscolor
            End If
            If Me.CrossesOver(Me.m_pctr, New Lambda(Of Double)( Function() Me.oversold)) Then
                MyBase.Alerts.Alert("Indicator exiting oversold zone", New Object(0 - 1) {})
            ElseIf Me.CrossesUnder(Me.m_pctr, New Lambda(Of Double)( Function() Me.overbought)) Then
                MyBase.Alerts.Alert("Indicator exiting overbought zone", New Object(0 - 1) {})
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_percentr1 = New PercentR(Me)
            Me.m_pctr = New VariableSeries(Of Double)(Me)
            Me.Plot1 = MyBase.AddPlot(New PlotAttributes("%R", EPlotShapes.Line, Color.Silver, Color.Empty, 0, 0, True))
            Me.Plot2 = MyBase.AddPlot(New PlotAttributes("OverBot", EPlotShapes.Line, Color.Green, Color.Empty, 0, 0, True))
            Me.Plot3 = MyBase.AddPlot(New PlotAttributes("OverSld", EPlotShapes.Line, Color.Green, Color.Empty, 0, 0, True))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_percentr1.length = New Lambda(Of Integer)( Function() Me.length)
            Me.m_pctr.DefaultValue = 0
        End Sub


        ' Properties
        <Input()> _
        Public Property length As Integer
            Get
                Return Me.m_length
            End Get
            Set(ByVal value As Integer)
                Me.m_length = value
            End Set
        End Property

        <Input()> _
        Public Property overbcolor As KnownColor
            Get
                Return Me.m_overbcolor.ToKnownColor
            End Get
            Set(ByVal value As KnownColor)
                Me.m_overbcolor = Color.FromKnownColor(value)
            End Set
        End Property

        <Input()> _
        Public Property overbought As Double
            Get
                Return Me.m_overbought
            End Get
            Set(ByVal value As Double)
                Me.m_overbought = value
            End Set
        End Property

        <Input()> _
        Public Property overscolor As KnownColor
            Get
                Return Me.m_overscolor.ToKnownColor
            End Get
            Set(ByVal value As KnownColor)
                Me.m_overscolor = Color.FromKnownColor(value)
            End Set
        End Property

        <Input()> _
        Public Property oversold As Double
            Get
                Return Me.m_oversold
            End Get
            Set(ByVal value As Double)
                Me.m_oversold = value
            End Set
        End Property


        ' Fields
        Private m_length As Integer
        Private m_overbcolor As Color
        Private m_overbought As Double
        Private m_overscolor As Color
        Private m_oversold As Double
        Private m_pctr As VariableSeries(Of Double)
        Private m_percentr1 As PercentR
        Private Plot1 As IPlotObject
        Private Plot2 As IPlotObject
        Private Plot3 As IPlotObject
    End Class
End Namespace

