﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System
Imports System.Drawing

Namespace PowerLanguage.Indicator
    <SameAsSymbol(True)> _
    Public Class Pennant_Brkout
        Inherits IndicatorObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_length = 7
            Me.m_maxconsolindex = 1.5
            Me.m_barspast = 5
            Me.m_drawlines = True
            Me.m_drawextensions = True
            Me.m_color1 = Color.Red
            Me.m_color2 = Color.Magenta
        End Sub

        Protected Overrides Sub CalcBar()
            Me.m_value1 = Me.m_pennant1.Item(0)
            If (Me.m_value1 = 1) Then
                If (Me.m_color.Value = Me.m_color2) Then
                    Me.m_color.Value = Me.m_color1
                Else
                    Me.m_color.Value = Me.m_color2
                End If
                If Me.drawlines Then
                    Me.m_tlhi.Value = MyBase.DrwTrendLine.Create(New ChartPoint(MyBase.Bars.Time.Item(Me.m_lengthminus1), Me.m_otlhistartpr.Value), New ChartPoint(MyBase.Bars.Time.Item(0), Me.m_otlhiendpr.Value))
                    Me.m_tlhi.Value.ExtLeft = False
                    Me.m_tlhi.Value.ExtRight = False
                    Me.m_tlhi.Value.Color = Me.m_color.Value
                    Me.m_tllo.Value = MyBase.DrwTrendLine.Create(New ChartPoint(MyBase.Bars.Time.Item(Me.m_lengthminus1), Me.m_otllostartpr.Value), New ChartPoint(MyBase.Bars.Time.Item(0), Me.m_otlloendpr.Value))
                    Me.m_tllo.Value.ExtLeft = False
                    Me.m_tllo.Value.ExtRight = False
                    Me.m_tllo.Value.Color = Me.m_color.Value
                End If
            ElseIf ((Me.m_value1 = 2) OrElse (Me.m_value1 = 3)) Then
                If Me.drawlines Then
                    Me.m_tlhi.Value.Size = 2
                    Me.m_tllo.Value.Size = 2
                End If
                If (Me.m_value1 = 2) Then
                    Me.Plot1.Set(0, MyBase.Bars.High.Item(0))
                ElseIf (Me.m_value1 = 3) Then
                    Me.Plot2.Set(0, MyBase.Bars.Low.Item(0))
                End If
            End If
            If Me.drawextensions Then
                If PublicFunctions.DoubleGreater(Me.m_otlhiendpr.Value, 0) Then
                    Me.Plot3.Set(0, Me.m_otlhiendpr.Value, Me.m_color.Value)
                End If
                If PublicFunctions.DoubleGreater(Me.m_otlloendpr.Value, 0) Then
                    Me.Plot4.Set(0, Me.m_otlloendpr.Value, Me.m_color.Value)
                End If
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_pennant1 = New Pennant(Me)
            Me.m_otlhistartpr = New VariableObject(Of Double)(Me)
            Me.m_otlhiendpr = New VariableObject(Of Double)(Me)
            Me.m_otllostartpr = New VariableObject(Of Double)(Me)
            Me.m_otlloendpr = New VariableObject(Of Double)(Me)
            Me.m_color = New VariableObject(Of Color)(Me)
            Me.m_tlhi = New VariableObject(Of ITrendLineObject)(Me)
            Me.m_tllo = New VariableObject(Of ITrendLineObject)(Me)
            Me.Plot1 = MyBase.AddPlot(New PlotAttributes("PenBrkoutUp", EPlotShapes.Point, Color.Cyan, Color.Empty, 5, 0, True))
            Me.Plot2 = MyBase.AddPlot(New PlotAttributes("PenBrkoutDn", EPlotShapes.Point, Color.Yellow, Color.Empty, 5, 0, True))
            Me.Plot3 = MyBase.AddPlot(New PlotAttributes("HiExt", EPlotShapes.Point, Color.Silver, Color.Empty, 3, 0, True))
            Me.Plot4 = MyBase.AddPlot(New PlotAttributes("LoExt", EPlotShapes.Point, Color.Silver, Color.Empty, 3, 0, True))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_pennant1.length = New Lambda(Of Integer)( Function() Me.length)
            Me.m_pennant1.maxconsolindex = New Lambda(Of Double)( Function() Me.maxconsolindex)
            Me.m_pennant1.barspast = New Lambda(Of Integer)( Function() Me.barspast)
            Me.m_pennant1.otlhistartpr = Me.m_otlhistartpr
            Me.m_pennant1.otlhiendpr = Me.m_otlhiendpr
            Me.m_pennant1.otllostartpr = Me.m_otllostartpr
            Me.m_pennant1.otlloendpr = Me.m_otlloendpr
            Me.m_value1 = 0
            Me.m_lengthminus1 = (Me.length - 1)
            Me.m_otlhistartpr.DefaultValue = 0
            Me.m_otlhiendpr.DefaultValue = 0
            Me.m_otllostartpr.DefaultValue = 0
            Me.m_otlloendpr.DefaultValue = 0
            Me.m_color.DefaultValue = Me.m_color2
            Me.m_tlhi.DefaultValue = Nothing
            Me.m_tllo.DefaultValue = Nothing
        End Sub


        ' Properties
        <Input()> _
        Public Property barspast As Integer
            Get
                Return Me.m_barspast
            End Get
            Set(ByVal value As Integer)
                Me.m_barspast = value
            End Set
        End Property

        <Input()> _
        Public Property color1 As KnownColor
            Get
                Return Me.m_color1.ToKnownColor
            End Get
            Set(ByVal value As KnownColor)
                Me.m_color1 = Color.FromKnownColor(value)
            End Set
        End Property

        <Input()> _
        Public Property color2 As KnownColor
            Get
                Return Me.m_color2.ToKnownColor
            End Get
            Set(ByVal value As KnownColor)
                Me.m_color2 = Color.FromKnownColor(value)
            End Set
        End Property

        <Input()> _
        Public Property drawextensions As Boolean
            Get
                Return Me.m_drawextensions
            End Get
            Set(ByVal value As Boolean)
                Me.m_drawextensions = value
            End Set
        End Property

        <Input()> _
        Public Property drawlines As Boolean
            Get
                Return Me.m_drawlines
            End Get
            Set(ByVal value As Boolean)
                Me.m_drawlines = value
            End Set
        End Property

        <Input()> _
        Public Property length As Integer
            Get
                Return Me.m_length
            End Get
            Set(ByVal value As Integer)
                Me.m_length = value
            End Set
        End Property

        <Input()> _
        Public Property maxconsolindex As Double
            Get
                Return Me.m_maxconsolindex
            End Get
            Set(ByVal value As Double)
                Me.m_maxconsolindex = value
            End Set
        End Property


        ' Fields
        Private m_barspast As Integer
        Private m_color As VariableObject(Of Color)
        Private m_color1 As Color
        Private m_color2 As Color
        Private m_drawextensions As Boolean
        Private m_drawlines As Boolean
        Private m_length As Integer
        Private m_lengthminus1 As Integer
        Private m_maxconsolindex As Double
        Private m_otlhiendpr As VariableObject(Of Double)
        Private m_otlhistartpr As VariableObject(Of Double)
        Private m_otlloendpr As VariableObject(Of Double)
        Private m_otllostartpr As VariableObject(Of Double)
        Private m_pennant1 As Pennant
        Private m_tlhi As VariableObject(Of ITrendLineObject)
        Private m_tllo As VariableObject(Of ITrendLineObject)
        Private m_value1 As Double
        Private Plot1 As IPlotObject
        Private Plot2 As IPlotObject
        Private Plot3 As IPlotObject
        Private Plot4 As IPlotObject
    End Class
End Namespace

