﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System
Imports System.Drawing

Namespace PowerLanguage.Indicator
    <SameAsSymbol(True)> _
    Public Class Pivot_High
        Inherits IndicatorObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_leftstrength = 3
            Me.m_rightstrength = 3
        End Sub

        Protected Overrides Sub CalcBar()
            If (Not Me.m_pivothighvsbar1.Item(0) = -1) Then
                Me.Plot1.Set(Me.rightstrength, MyBase.Bars.High.Item(Me.rightstrength))
                MyBase.Alerts.Alert
            Else
                Me.Plot1.Reset
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_pivothighvsbar1 = New PivotHighVSBar(Me)
            Me.Plot1 = MyBase.AddPlot(New PlotAttributes("PivotHi", EPlotShapes.Point, Color.Blue, Color.Empty, 4, 0, True))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_price = MyBase.Bars.High
            Me.m_pivothighvsbar1.instance = New ConstantObject(Of Integer)(1)
            Me.m_pivothighvsbar1.price = Me.price
            Me.m_pivothighvsbar1.leftstrength = New Lambda(Of Integer)( Function() Me.leftstrength)
            Me.m_pivothighvsbar1.rightstrength = New Lambda(Of Integer)( Function() Me.rightstrength)
            Me.m_pivothighvsbar1.length = New Lambda(Of Integer)( Function() (Me.rightstrength + 1))
        End Sub


        ' Properties
        <Input> _
        Public Property leftstrength As Integer
            Get
                Return Me.m_leftstrength
            End Get
            Set(ByVal value As Integer)
                Me.m_leftstrength = value
            End Set
        End Property

        Private ReadOnly Property price As ISeries(Of Double)
            Get
                Return Me.m_price
            End Get
        End Property

        <Input()> _
        Public Property rightstrength As Integer
            Get
                Return Me.m_rightstrength
            End Get
            Set(ByVal value As Integer)
                Me.m_rightstrength = value
            End Set
        End Property


        ' Fields
        Private m_leftstrength As Integer
        Private m_pivothighvsbar1 As PivotHighVSBar
        Private m_price As ISeries(Of Double)
        Private m_rightstrength As Integer
        Private Plot1 As IPlotObject
    End Class
End Namespace

