﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System
Imports System.Drawing

Namespace PowerLanguage.Indicator
    <SameAsSymbol(True)> _
    Public Class Pivot_Rev_Gen__Dn
        Inherits IndicatorObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_minrstren = 1
            Me.m_maxrstren = 30
            Me.m_lrfactor = 1
            Me.m_drawlines = True
            Me.m_linescolor = Color.Magenta
            Me.m_plotcolor = Color.Cyan
            Me.m_colorscheme = 1
        End Sub

        Protected Overrides Sub CalcBar()
            Me.m_value1 = Me.m_pivotreversalgen1.Item(0)
            If (Me.m_value1 = 1) Then
                Me.Plot1.Set(0, Me.m_opivotprice.Value)
                If (Me.colorscheme = 1) Then
                    Me.Plot1.Colors.Item(0) = Me.m_plotcolor
                ElseIf (Me.colorscheme = 2) Then
                    Me.Plot1.BGColor = Me.m_plotcolor
                End If
                MyBase.Alerts.Alert(String.Concat(New Object() { "Pivot reversal: Lo = ", Math.Round(Me.m_opivotprice.Value, 2), ", RS = ", Math.Round(Me.m_opivotrstren.Value, 0), ", LS = ", Math.Round(Me.m_opivotlstren.Value, 0) }), New Object(0  - 1) {})
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_pivotreversalgen1 = New PivotReversalGen(Me)
            Me.m_opivotprice = New VariableObject(Of Double)(Me)
            Me.m_opivotrstren = New VariableObject(Of Double)(Me)
            Me.m_opivotlstren = New VariableObject(Of Double)(Me)
            Me.Plot1 = MyBase.AddPlot(New PlotAttributes("PivRev_Dn", EPlotShapes.Point, Color.Cyan, Color.Empty, 4, 0, True))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_pivotreversalgen1.minrstren = New Lambda(Of Double)( Function() Me.minrstren)
            Me.m_pivotreversalgen1.maxrstren = New Lambda(Of Double)( Function() Me.maxrstren)
            Me.m_pivotreversalgen1.lrfactor = New Lambda(Of Double)( Function() Me.lrfactor)
            Me.m_pivotreversalgen1.hilo = New ConstantObject(Of Integer)(-1)
            Me.m_pivotreversalgen1.drawlines = New Lambda(Of Boolean)( Function() Me.drawlines)
            Me.m_pivotreversalgen1.linescolor = New Lambda(Of Color)( Function() Me.m_linescolor)
            Me.m_pivotreversalgen1.opivotprice = Me.m_opivotprice
            Me.m_pivotreversalgen1.opivotrstren = Me.m_opivotrstren
            Me.m_pivotreversalgen1.opivotlstren = Me.m_opivotlstren
            Me.m_value1 = 0
            Me.m_opivotprice.DefaultValue = 0
            Me.m_opivotrstren.DefaultValue = 0
            Me.m_opivotlstren.DefaultValue = 0
        End Sub


        ' Properties
        <Input()> _
        Public Property colorscheme As Integer
            Get
                Return Me.m_colorscheme
            End Get
            Set(ByVal value As Integer)
                Me.m_colorscheme = value
            End Set
        End Property

        <Input()> _
        Public Property drawlines As Boolean
            Get
                Return Me.m_drawlines
            End Get
            Set(ByVal value As Boolean)
                Me.m_drawlines = value
            End Set
        End Property

        <Input()> _
        Public Property linescolor As KnownColor
            Get
                Return Me.m_linescolor.ToKnownColor
            End Get
            Set(ByVal value As KnownColor)
                Me.m_linescolor = Color.FromKnownColor(value)
            End Set
        End Property

        <Input()> _
        Public Property lrfactor As Double
            Get
                Return Me.m_lrfactor
            End Get
            Set(ByVal value As Double)
                Me.m_lrfactor = value
            End Set
        End Property

        <Input()> _
        Public Property maxrstren As Double
            Get
                Return Me.m_maxrstren
            End Get
            Set(ByVal value As Double)
                Me.m_maxrstren = value
            End Set
        End Property

        <Input()> _
        Public Property minrstren As Double
            Get
                Return Me.m_minrstren
            End Get
            Set(ByVal value As Double)
                Me.m_minrstren = value
            End Set
        End Property

        <Input()> _
        Public Property plotcolor As KnownColor
            Get
                Return Me.m_plotcolor.ToKnownColor
            End Get
            Set(ByVal value As KnownColor)
                Me.m_plotcolor = Color.FromKnownColor(value)
            End Set
        End Property


        ' Fields
        Private m_colorscheme As Integer
        Private m_drawlines As Boolean
        Private m_linescolor As Color
        Private m_lrfactor As Double
        Private m_maxrstren As Double
        Private m_minrstren As Double
        Private m_opivotlstren As VariableObject(Of Double)
        Private m_opivotprice As VariableObject(Of Double)
        Private m_opivotrstren As VariableObject(Of Double)
        Private m_pivotreversalgen1 As PivotReversalGen
        Private m_plotcolor As Color
        Private m_value1 As Double
        Private Plot1 As IPlotObject
    End Class
End Namespace

