﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System
Imports System.Drawing

Namespace PowerLanguage.Indicator
    Public Class Stochastic_Fast
        Inherits IndicatorObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_stochlength = 14
            Me.m_smoothinglength1 = 3
            Me.m_smoothinglength2 = 3
            Me.m_smoothingtype = 1
            Me.m_oversold = 20
            Me.m_overbought = 80
        End Sub

        Protected Overrides Sub CalcBar()
            Me.m_value1 = Me.m_stochastic1.Item(0)
            Me.Plot1.Set(0, Me.m_ofastk.Value)
            Me.Plot2.Set(0, Me.m_ofastd.Value)
            Me.Plot3.Set(0, Me.overbought)
            Me.Plot4.Set(0, Me.oversold)
            If Me.CrossesOver(Me.m_ofastd, New Lambda(Of Double)( Function() Me.oversold)) Then
                MyBase.Alerts.Alert("FastD exiting oversold zone", New Object(0 - 1) {})
            ElseIf Me.CrossesUnder(Me.m_ofastd, New Lambda(Of Double)( Function() Me.overbought)) Then
                MyBase.Alerts.Alert("FastD exiting overbought zone", New Object(0 - 1) {})
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_stochastic1 = New Stochastic(Me)
            Me.m_ofastk = New VariableSeries(Of Double)(Me)
            Me.m_ofastd = New VariableSeries(Of Double)(Me)
            Me.m_oslowk = New VariableObject(Of Double)(Me)
            Me.m_oslowd = New VariableObject(Of Double)(Me)
            Me.Plot1 = MyBase.AddPlot(New PlotAttributes("FastK", EPlotShapes.Line, Color.Yellow, Color.Empty, 0, 0, True))
            Me.Plot2 = MyBase.AddPlot(New PlotAttributes("FastD", EPlotShapes.Line, Color.Blue, Color.Empty, 0, 0, True))
            Me.Plot3 = MyBase.AddPlot(New PlotAttributes("OverBot", EPlotShapes.Line, Color.Green, Color.Empty, 0, 0, True))
            Me.Plot4 = MyBase.AddPlot(New PlotAttributes("OverSld", EPlotShapes.Line, Color.Green, Color.Empty, 0, 0, True))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_priceh = MyBase.Bars.High
            Me.m_pricel = MyBase.Bars.Low
            Me.m_pricec = MyBase.Bars.Close
            Me.m_stochastic1.priceh = Me.priceh
            Me.m_stochastic1.pricel = Me.pricel
            Me.m_stochastic1.pricec = Me.pricec
            Me.m_stochastic1.stochlength = New Lambda(Of Integer)( Function() Me.stochlength)
            Me.m_stochastic1.length1 = Me.smoothinglength1
            Me.m_stochastic1.length2 = New Lambda(Of Integer)( Function() Me.smoothinglength2)
            Me.m_stochastic1.smoothingtype = New Lambda(Of Integer)( Function() Me.smoothingtype)
            Me.m_stochastic1.ofastk = Me.m_ofastk
            Me.m_stochastic1.ofastd = Me.m_ofastd
            Me.m_stochastic1.oslowk = Me.m_oslowk
            Me.m_stochastic1.oslowd = Me.m_oslowd
            Me.m_value1 = 0
            Me.m_ofastk.DefaultValue = 0
            Me.m_ofastd.DefaultValue = 0
            Me.m_oslowk.DefaultValue = 0
            Me.m_oslowd.DefaultValue = 0
        End Sub


        ' Properties
        <Input()> _
        Public Property overbought As Double
            Get
                Return Me.m_overbought
            End Get
            Set(ByVal value As Double)
                Me.m_overbought = value
            End Set
        End Property

        <Input()> _
        Public Property oversold As Double
            Get
                Return Me.m_oversold
            End Get
            Set(ByVal value As Double)
                Me.m_oversold = value
            End Set
        End Property

        Private ReadOnly Property pricec As ISeries(Of Double)
            Get
                Return Me.m_pricec
            End Get
        End Property

        Private ReadOnly Property priceh As ISeries(Of Double)
            Get
                Return Me.m_priceh
            End Get
        End Property

        Private ReadOnly Property pricel As ISeries(Of Double)
            Get
                Return Me.m_pricel
            End Get
        End Property

        <Input()> _
        Public Property smoothinglength1 As Integer
            Get
                Return Me.m_smoothinglength1
            End Get
            Set(ByVal value As Integer)
                Me.m_smoothinglength1 = value
            End Set
        End Property

        <Input()> _
        Public Property smoothinglength2 As Integer
            Get
                Return Me.m_smoothinglength2
            End Get
            Set(ByVal value As Integer)
                Me.m_smoothinglength2 = value
            End Set
        End Property

        <Input()> _
        Public Property smoothingtype As Integer
            Get
                Return Me.m_smoothingtype
            End Get
            Set(ByVal value As Integer)
                Me.m_smoothingtype = value
            End Set
        End Property

        <Input()> _
        Public Property stochlength As Integer
            Get
                Return Me.m_stochlength
            End Get
            Set(ByVal value As Integer)
                Me.m_stochlength = value
            End Set
        End Property


        ' Fields
        Private m_ofastd As VariableSeries(Of Double)
        Private m_ofastk As VariableSeries(Of Double)
        Private m_oslowd As VariableObject(Of Double)
        Private m_oslowk As VariableObject(Of Double)
        Private m_overbought As Double
        Private m_oversold As Double
        Private m_pricec As ISeries(Of Double)
        Private m_priceh As ISeries(Of Double)
        Private m_pricel As ISeries(Of Double)
        Private m_smoothinglength1 As Integer
        Private m_smoothinglength2 As Integer
        Private m_smoothingtype As Integer
        Private m_stochastic1 As Stochastic
        Private m_stochlength As Integer
        Private m_value1 As Double
        Private Plot1 As IPlotObject
        Private Plot2 As IPlotObject
        Private Plot3 As IPlotObject
        Private Plot4 As IPlotObject
    End Class
End Namespace

