﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System
Imports System.Drawing

Namespace PowerLanguage.Indicator
    Public Class TRIX
        Inherits IndicatorObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_length = 9
            Me.m_colornormlength = 14
            Me.m_upcolor = Color.Yellow
            Me.m_dncolor = Color.Red
            Me.m_gridforegroundcolor = Color.FromKnownColor(KnownColor.Black)
        End Sub

        Protected Overrides Sub CalcBar()
            If (MyBase.Bars.CurrentBar = 1) Then
                Me.m_applicationtype.Value = DirectCast(MyBase.Environment.ApplicationCode, Integer)
            End If
            Me.m_trixvalue.Value = Me.m_trix1.Item(0)
            Me.Plot1.Set(0, Me.m_trixvalue.Value)
            Me.Plot2.Set(0, 0)
            Me.m_colorlevel = Me.m_normgradientcolor1.Item(0)
            If (Me.m_applicationtype.Value = 1) Then
                Me.Plot1.Colors.Item(0) = Me.m_colorlevel
            ElseIf (Me.m_applicationtype.Value > 1) Then
                Me.Plot1.Colors.Item(0) = Me.m_gridforegroundcolor
                Me.Plot1.BGColor = Me.m_colorlevel
            End If
            If DirectCast(Me, IStudy).CrossesOver(DirectCast(Me.m_trixvalue, ISeries(Of Double)), CDbl(0)) Then
                MyBase.Alerts.Alert("Indicator turning positive", New Object(0 - 1) {})
            ElseIf DirectCast(Me, IStudy).CrossesUnder(DirectCast(Me.m_trixvalue, ISeries(Of Double)), CDbl(0)) Then
                MyBase.Alerts.Alert("Indicator turning negative", New Object(0 - 1) {})
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_trix1 = New PowerLanguage.Function.TRIX(Me)
            Me.m_normgradientcolor1 = New NormGradientColor(Me)
            Me.m_applicationtype = New VariableObject(Of Integer)(Me)
            Me.m_trixvalue = New VariableSeries(Of Double)(Me)
            Me.Plot1 = MyBase.AddPlot(New PlotAttributes("TRIX", EPlotShapes.Line, Color.Yellow, Color.Empty, 0, 0, True))
            Me.Plot2 = MyBase.AddPlot(New PlotAttributes("ZeroLine", EPlotShapes.Line, Color.Green, Color.Empty, 0, 0, True))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_price = New Lambda(Of Double)( Function() MyBase.Bars.Close.Item(0))
            Me.m_trix1.price = Me.price
            Me.m_trix1.length = Me.length
            Me.m_normgradientcolor1.dataseriesvalue = Me.m_trixvalue
            Me.m_normgradientcolor1.crosseszero = New ConstantObject(Of Boolean)(True)
            Me.m_normgradientcolor1.colornormlength = New Lambda(Of Integer)( Function() Me.colornormlength)
            Me.m_normgradientcolor1.upcolor = New Lambda(Of Color)( Function() Me.m_upcolor)
            Me.m_normgradientcolor1.dncolor = New Lambda(Of Color)( Function() Me.m_dncolor)
            Me.m_applicationtype.DefaultValue = 0
            Me.m_trixvalue.DefaultValue = 0
            Me.m_colorlevel = Color.Empty
        End Sub


        ' Properties
        <Input()> _
        Public Property colornormlength As Integer
            Get
                Return Me.m_colornormlength
            End Get
            Set(ByVal value As Integer)
                Me.m_colornormlength = value
            End Set
        End Property

        <Input()> _
        Public Property dncolor As KnownColor
            Get
                Return Me.m_dncolor.ToKnownColor
            End Get
            Set(ByVal value As KnownColor)
                Me.m_dncolor = Color.FromKnownColor(value)
            End Set
        End Property

        <Input()> _
        Public Property gridforegroundcolor As KnownColor
            Get
                Return Me.m_gridforegroundcolor.ToKnownColor
            End Get
            Set(ByVal value As KnownColor)
                Me.m_gridforegroundcolor = Color.FromKnownColor(value)
            End Set
        End Property

        <Input()> _
        Public Property length As Integer
            Get
                Return Me.m_length
            End Get
            Set(ByVal value As Integer)
                Me.m_length = value
            End Set
        End Property

        Private ReadOnly Property price As ISeries(Of Double)
            Get
                Return Me.m_price
            End Get
        End Property

        <Input()> _
        Public Property upcolor As KnownColor
            Get
                Return Me.m_upcolor.ToKnownColor
            End Get
            Set(ByVal value As KnownColor)
                Me.m_upcolor = Color.FromKnownColor(value)
            End Set
        End Property


        ' Fields
        Private m_applicationtype As VariableObject(Of Integer)
        Private m_colorlevel As Color
        Private m_colornormlength As Integer
        Private m_dncolor As Color
        Private m_gridforegroundcolor As Color
        Private m_length As Integer
        Private m_normgradientcolor1 As NormGradientColor
        Private m_price As ISeries(Of Double)
        Private m_trix1 As PowerLanguage.Function.TRIX
        Private m_trixvalue As VariableSeries(Of Double)
        Private m_upcolor As Color
        Private Plot1 As IPlotObject
        Private Plot2 As IPlotObject
    End Class
End Namespace

