﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System
Imports System.Drawing

Namespace PowerLanguage.Indicator
    <SameAsSymbol(True)> _
    Public Class Time_Series_Forecast
        Inherits IndicatorObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_length = 9
            Me.m_barsplus = 7
        End Sub

        Protected Overrides Sub CalcBar()
            Me.m_tsf.Value = Me.m_timeseriesforecast1.Item(0)
            Me.Plot1.Set(0, Me.m_tsf.Value)
            If ((PublicFunctions.DoubleGreater(MyBase.Bars.Close.Item(0), Me.m_tsf.Value) AndAlso PublicFunctions.DoubleGreater(Me.m_tsf.Value, Me.m_tsf.Item(1))) AndAlso PublicFunctions.DoubleLessEquals(Me.m_tsf.Item(1), Me.m_tsf.Item(2))) Then
                MyBase.Alerts.Alert("Indicator turning up", New Object(0  - 1) {})
            ElseIf ((PublicFunctions.DoubleLess(MyBase.Bars.Close.Item(0), Me.m_tsf.Value) AndAlso PublicFunctions.DoubleLess(Me.m_tsf.Value, Me.m_tsf.Item(1))) AndAlso PublicFunctions.DoubleGreaterEquals(Me.m_tsf.Item(1), Me.m_tsf.Item(2))) Then
                MyBase.Alerts.Alert("Indicator turning down", New Object(0  - 1) {})
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_timeseriesforecast1 = New TimeSeriesForecast(Me)
            Me.m_tsf = New VariableSeries(Of Double)(Me)
            Me.Plot1 = MyBase.AddPlot(New PlotAttributes("TSF", EPlotShapes.Line, Color.Blue, Color.Empty, 0, 0, True))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_timeseriesforecast1.length = New Lambda(Of Integer)( Function() Me.length)
            Me.m_timeseriesforecast1.tgtbar = New Lambda(Of Integer)( Function() Me.barsplus)
            Me.m_tsf.DefaultValue = 0
        End Sub


        ' Properties
        <Input()> _
        Public Property barsplus As Integer
            Get
                Return Me.m_barsplus
            End Get
            Set(ByVal value As Integer)
                Me.m_barsplus = value
            End Set
        End Property

        <Input()> _
        Public Property length As Integer
            Get
                Return Me.m_length
            End Get
            Set(ByVal value As Integer)
                Me.m_length = value
            End Set
        End Property


        ' Fields
        Private m_barsplus As Integer
        Private m_length As Integer
        Private m_timeseriesforecast1 As TimeSeriesForecast
        Private m_tsf As VariableSeries(Of Double)
        Private Plot1 As IPlotObject
    End Class
End Namespace

