﻿Imports PowerLanguage
Imports System
Imports System.Drawing

Namespace PowerLanguage.Indicator
    Public Class Ulcer_Index
        Inherits IndicatorObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_length = 14
            Me.m_safelevel = 5
        End Sub

        Protected Overrides Sub CalcBar()
            Me.m_ulcerx.Value = Me.price.UlcerIndex(Me.length)
            Me.Plot1.Set(0, Me.m_ulcerx.Value)
            Me.Plot2.Set(0, Me.safelevel)
            If Me.CrossesOver(Me.m_ulcerx, New Lambda(Of Double)( Function() Me.safelevel)) Then
                MyBase.Alerts.Alert("Indicator crossing over Safe Level", New Object(0 - 1) {})
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_ulcerx = New VariableSeries(Of Double)(Me)
            Me.Plot1 = MyBase.AddPlot(New PlotAttributes("UlcerX", EPlotShapes.Line, Color.Blue, Color.Empty, 0, 0, True))
            Me.Plot2 = MyBase.AddPlot(New PlotAttributes("SafeLevel", EPlotShapes.Line, Color.Green, Color.Empty, 0, 0, True))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_price = MyBase.Bars.Close
            Me.m_ulcerx.DefaultValue = 0
        End Sub


        ' Properties
        <Input()> _
        Public Property length As Integer
            Get
                Return Me.m_length
            End Get
            Set(ByVal value As Integer)
                Me.m_length = value
            End Set
        End Property

        Private ReadOnly Property price As ISeries(Of Double)
            Get
                Return Me.m_price
            End Get
        End Property

        <Input()> _
        Public Property safelevel As Double
            Get
                Return Me.m_safelevel
            End Get
            Set(ByVal value As Double)
                Me.m_safelevel = value
            End Set
        End Property


        ' Fields
        Private m_length As Integer
        Private m_price As ISeries(Of Double)
        Private m_safelevel As Double
        Private m_ulcerx As VariableSeries(Of Double)
        Private Plot1 As IPlotObject
        Private Plot2 As IPlotObject
    End Class
End Namespace

