﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System
Imports System.Drawing
Imports System.Runtime.CompilerServices

Namespace PowerLanguage.Indicator
    <SameAsSymbol(True)> _
    Public Class VWAP_reset
        Inherits IndicatorObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_time1 = New DateTime(1, 1, 1, 9, 0, 0)
            Me.m_time2 = New DateTime(1, 1, 1, 9, 30, 0)
            Me.m_time3 = New DateTime(1, 1, 1, 11, &H1D, 0)
            Me.m_time4 = New DateTime(1, 1, 1, 13, 15, 0)
            Me.m_time5 = New DateTime(1, 1, 1, 14, 15, 0)
            Me.m_upcolor = Color.Cyan
            Me.m_dncolor = Color.Magenta
        End Sub

        Protected Overrides Sub CalcBar()
            Me.m_price.Value = Me.m_avgprice1.Item(0)
            Me.m_it.Value = Me.m_vwapresettable1.Item(0)
            Me.Plot1.Set(0, Me.m_it.Value)
            If PublicFunctions.DoubleGreater(Me.m_it.Value, Me.m_it.Item(1)) Then
                Me.m_color.Value = Me.m_upcolor
            End If
            If PublicFunctions.DoubleLess(Me.m_it.Value, Me.m_it.Item(1)) Then
                Me.m_color.Value = Me.m_dncolor
            End If
            Me.Plot1.Colors.Item(0) = Me.m_color.Value
        End Sub

        Protected Overrides Sub Create()
            Me.m_avgprice1 = New AvgPrice(Me)
            Me.m_vwapresettable1 = New vwapResettable(Me)
            Me.m_price = New VariableSeries(Of Double)(Me)
            Me.m_it = New VariableSeries(Of Double)(Me)
            Me.m_color = New VariableObject(Of Color)(Me)
            Me.Plot1 = MyBase.AddPlot(New PlotAttributes("vwap_reset", EPlotShapes.Point, Color.Blue, Color.Empty, 0, 0, True))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_vwapresettable1.price = Me.m_price
            Me.m_vwapresettable1.localhrsoffset = New Lambda(Of Integer)( Function() Me.localhrsoffset)
            Me.m_vwapresettable1.time1 = New Lambda(Of DateTime)( Function() Me.time1)
            Me.m_vwapresettable1.time2 = New Lambda(Of DateTime)( Function() Me.time2)
            Me.m_vwapresettable1.time3 = New Lambda(Of DateTime)( Function() Me.time3)
            Me.m_vwapresettable1.time4 = New Lambda(Of DateTime)( Function() Me.time4)
            Me.m_vwapresettable1.time5 = New Lambda(Of DateTime)( Function() Me.time5)
            Me.m_price.DefaultValue = 0
            Me.m_it.DefaultValue = 0
            Me.m_color.DefaultValue = Color.Yellow
        End Sub


        ' Properties
        <Input()> _
        Public Property dncolor As KnownColor
            Get
                Return Me.m_dncolor.ToKnownColor
            End Get
            Set(ByVal value As KnownColor)
                Me.m_dncolor = Color.FromKnownColor(value)
            End Set
        End Property

        Private m_localhrsoffset As Integer
        <Input()>
        Public Property localhrsoffset As Integer
            Set(ByVal value As Integer)
                m_localhrsoffset = value
            End Set
            Get
                Return m_localhrsoffset
            End Get
        End Property
        <Input> _
        Public Property time1 As DateTime
            Get
                Return Me.m_time1
            End Get
            Set(ByVal value As DateTime)
                Me.m_time1 = value
            End Set
        End Property

        <Input()> _
        Public Property time2 As DateTime
            Get
                Return Me.m_time2
            End Get
            Set(ByVal value As DateTime)
                Me.m_time2 = value
            End Set
        End Property

        <Input()> _
        Public Property time3 As DateTime
            Get
                Return Me.m_time3
            End Get
            Set(ByVal value As DateTime)
                Me.m_time3 = value
            End Set
        End Property

        <Input()> _
        Public Property time4 As DateTime
            Get
                Return Me.m_time4
            End Get
            Set(ByVal value As DateTime)
                Me.m_time4 = value
            End Set
        End Property

        <Input()> _
        Public Property time5 As DateTime
            Get
                Return Me.m_time5
            End Get
            Set(ByVal value As DateTime)
                Me.m_time5 = value
            End Set
        End Property

        <Input()> _
        Public Property upcolor As KnownColor
            Get
                Return Me.m_upcolor.ToKnownColor
            End Get
            Set(ByVal value As KnownColor)
                Me.m_upcolor = Color.FromKnownColor(value)
            End Set
        End Property


        ' Fields
        Private m_avgprice1 As AvgPrice
        Private m_color As VariableObject(Of Color)
        Private m_dncolor As Color
        Private m_it As VariableSeries(Of Double)
        Private m_price As VariableSeries(Of Double)
        Private m_time1 As DateTime
        Private m_time2 As DateTime
        Private m_time3 As DateTime
        Private m_time4 As DateTime
        Private m_time5 As DateTime
        Private m_upcolor As Color
        Private m_vwapresettable1 As vwapResettable
        Private Plot1 As IPlotObject
    End Class
End Namespace

