﻿Imports PowerLanguage
Imports System
Imports System.Drawing

Namespace PowerLanguage.Indicator
    <SameAsSymbol(True)> _
    Public Class Volume_Brkout
        Inherits IndicatorObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_avglength = 50
            Me.m_brkoutpct = 50
        End Sub

        Protected Overrides Sub CalcBar()
            Dim resolution As EResolution = MyBase.Bars.Info.Resolution.Type
            If ((((EResolution.Day = resolution) OrElse (EResolution.Week = resolution)) OrElse ((EResolution.Month = resolution) OrElse (EResolution.Quarter = resolution))) OrElse (EResolution.Year = resolution)) Then
                Me.m_condition1 = PublicFunctions.DoubleGreaterEquals(MyBase.Bars.Volume.Item(0), (PublicFunctions.Average(MyBase.Bars.Volume, Me.avglength) * Me.m_brkoutfactor))
            Else
                Me.m_condition1 = PublicFunctions.DoubleGreaterEquals(MyBase.Bars.Ticks.Item(0), (PublicFunctions.Average(MyBase.Bars.Ticks, Me.avglength) * Me.m_brkoutfactor))
            End If
            If Me.m_condition1 Then
                Me.Plot1.Set(0, MyBase.Bars.High.Item(0))
                MyBase.Alerts.Alert
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.Plot1 = MyBase.AddPlot(New PlotAttributes("VolBrkOut", EPlotShapes.Point, Color.Cyan, Color.Empty, 4, 0, True))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_condition1 = False
            Me.m_brkoutfactor = (1 + (Me.brkoutpct * 0.01))
        End Sub


        ' Properties
        <Input> _
        Public Property avglength As Integer
            Get
                Return Me.m_avglength
            End Get
            Set(ByVal value As Integer)
                Me.m_avglength = value
            End Set
        End Property

        <Input> _
        Public Property brkoutpct As Double
            Get
                Return Me.m_brkoutpct
            End Get
            Set(ByVal value As Double)
                Me.m_brkoutpct = value
            End Set
        End Property


        ' Fields
        Private m_avglength As Integer
        Private m_brkoutfactor As Double
        Private m_brkoutpct As Double
        Private m_condition1 As Boolean
        Private Plot1 As IPlotObject
    End Class
End Namespace

