﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System
Imports System.Drawing

Namespace PowerLanguage.Indicator
    Public Class Volume_Osc
        Inherits IndicatorObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_fastlength = 14
            Me.m_slowlength = &H1C
            Me.m_colornormlength = 14
            Me.m_upcolor = Color.Yellow
            Me.m_dncolor = Color.Magenta
            Me.m_gridforegroundcolor = Color.FromKnownColor(KnownColor.Black)
        End Sub

        Protected Overrides Sub CalcBar()
            If (MyBase.Bars.CurrentBar = 1) Then
                Me.m_applicationtype.Value = DirectCast(MyBase.Environment.ApplicationCode, Integer)
            End If
            Me.m_volosc.Value = Me.m_volumeosc1.Item(0)
            Me.Plot1.Set(0, Me.m_volosc.Value)
            Me.Plot2.Set(0, 0)
            Me.m_colorlevel = Me.m_normgradientcolor1.Item(0)
            If (Me.m_applicationtype.Value = 1) Then
                Me.Plot1.Colors.Item(0) = Me.m_colorlevel
            ElseIf (Me.m_applicationtype.Value > 1) Then
                Me.Plot1.Colors.Item(0) = Me.m_gridforegroundcolor
                Me.Plot1.BGColor = Me.m_colorlevel
            End If
            If DirectCast(Me, IStudy).CrossesOver(DirectCast(Me.m_volosc, ISeries(Of Double)), CDbl(0)) Then
                MyBase.Alerts.Alert("Indicator turning positive", New Object(0 - 1) {})
            ElseIf DirectCast(Me, IStudy).CrossesUnder(DirectCast(Me.m_volosc, ISeries(Of Double)), CDbl(0)) Then
                MyBase.Alerts.Alert("Indicator turning negative", New Object(0 - 1) {})
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_volumeosc1 = New VolumeOsc(Me)
            Me.m_normgradientcolor1 = New NormGradientColor(Me)
            Me.m_applicationtype = New VariableObject(Of Integer)(Me)
            Me.m_volosc = New VariableSeries(Of Double)(Me)
            Me.Plot1 = MyBase.AddPlot(New PlotAttributes("VolOsc", EPlotShapes.Line, Color.Cyan, Color.Empty, 0, 0, True))
            Me.Plot2 = MyBase.AddPlot(New PlotAttributes("ZeroLine", EPlotShapes.Line, Color.Green, Color.Empty, 0, 0, True))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_volumeosc1.fastlength = New Lambda(Of Integer)( Function() Me.fastlength)
            Me.m_volumeosc1.slowlength = New Lambda(Of Integer)( Function() Me.slowlength)
            Me.m_normgradientcolor1.dataseriesvalue = Me.m_volosc
            Me.m_normgradientcolor1.crosseszero = New ConstantObject(Of Boolean)(True)
            Me.m_normgradientcolor1.colornormlength = New Lambda(Of Integer)( Function() Me.colornormlength)
            Me.m_normgradientcolor1.upcolor = New Lambda(Of Color)( Function() Me.m_upcolor)
            Me.m_normgradientcolor1.dncolor = New Lambda(Of Color)( Function() Me.m_dncolor)
            Me.m_applicationtype.DefaultValue = 0
            Me.m_volosc.DefaultValue = 0
            Me.m_colorlevel = Color.Empty
        End Sub


        ' Properties
        <Input()> _
        Public Property colornormlength As Integer
            Get
                Return Me.m_colornormlength
            End Get
            Set(ByVal value As Integer)
                Me.m_colornormlength = value
            End Set
        End Property

        <Input()> _
        Public Property dncolor As KnownColor
            Get
                Return Me.m_dncolor.ToKnownColor
            End Get
            Set(ByVal value As KnownColor)
                Me.m_dncolor = Color.FromKnownColor(value)
            End Set
        End Property

        <Input()> _
        Public Property fastlength As Integer
            Get
                Return Me.m_fastlength
            End Get
            Set(ByVal value As Integer)
                Me.m_fastlength = value
            End Set
        End Property

        <Input()> _
        Public Property gridforegroundcolor As KnownColor
            Get
                Return Me.m_gridforegroundcolor.ToKnownColor
            End Get
            Set(ByVal value As KnownColor)
                Me.m_gridforegroundcolor = Color.FromKnownColor(value)
            End Set
        End Property

        <Input()> _
        Public Property slowlength As Integer
            Get
                Return Me.m_slowlength
            End Get
            Set(ByVal value As Integer)
                Me.m_slowlength = value
            End Set
        End Property

        <Input()> _
        Public Property upcolor As KnownColor
            Get
                Return Me.m_upcolor.ToKnownColor
            End Get
            Set(ByVal value As KnownColor)
                Me.m_upcolor = Color.FromKnownColor(value)
            End Set
        End Property


        ' Fields
        Private m_applicationtype As VariableObject(Of Integer)
        Private m_colorlevel As Color
        Private m_colornormlength As Integer
        Private m_dncolor As Color
        Private m_fastlength As Integer
        Private m_gridforegroundcolor As Color
        Private m_normgradientcolor1 As NormGradientColor
        Private m_slowlength As Integer
        Private m_upcolor As Color
        Private m_volosc As VariableSeries(Of Double)
        Private m_volumeosc1 As VolumeOsc
        Private Plot1 As IPlotObject
        Private Plot2 As IPlotObject
    End Class
End Namespace

