﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System

Namespace PowerLanguage.Strategy
    Public Class ATR_Trailing_LX
        Inherits SignalObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_atrlength = 10
            Me.m_numatrs = 3
        End Sub

        Protected Overrides Sub CalcBar()
            Me.m_atrcalc = (Me.m_avgtruerange1.Item(0) * Me.numatrs)
            Me.m_mp.Value = 0
            If (MyBase.StrategyInfo.MarketPosition > 0) Then
                Me.m_mp.Value = 1
            End If
            If (MyBase.StrategyInfo.MarketPosition < 0) Then
                Me.m_mp.Value = -1
            End If
            If (Me.m_mp.Value = 1) Then
                Me.m_condition1 = ((Not Me.m_mp.Item(1) = 1) OrElse PublicFunctions.DoubleGreater(MyBase.Bars.High.Item(0), Me.m_poshigh.Value))
                If Me.m_condition1 Then
                    Me.m_poshigh.Value = MyBase.Bars.High.Item(0)
                End If
                Me.m_Order0.Send((Me.m_poshigh.Value - Me.m_atrcalc))
            Else
                Me.m_Order1.Send((MyBase.Bars.High.Item(0) - Me.m_atrcalc))
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_avgtruerange1 = New AvgTrueRange(Me)
            Me.m_mp = New VariableSeries(Of Double)(Me)
            Me.m_poshigh = New VariableObject(Of Double)(Me)
            Me.m_Order0 = MyBase.OrderCreator.Stop(New SOrderParameters(Contracts.Default, "AtrLX", EOrderAction.Sell, OrderExit.FromAll))
            Me.m_Order1 = MyBase.OrderCreator.Stop(New SOrderParameters(Contracts.Default, "AtrLX-eb", EOrderAction.Sell, OrderExit.FromAll))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_avgtruerange1.length = New Lambda(Of Integer)( Function() Me.atrlength)
            Me.m_condition1 = False
            Me.m_atrcalc = 0
            Me.m_mp.DefaultValue = 0
            Me.m_poshigh.DefaultValue = 0
        End Sub


        ' Properties
        <Input()> _
        Public Property atrlength As Integer
            Get
                Return Me.m_atrlength
            End Get
            Set(ByVal value As Integer)
                Me.m_atrlength = value
            End Set
        End Property

        <Input()> _
        Public Property numatrs As Integer
            Get
                Return Me.m_numatrs
            End Get
            Set(ByVal value As Integer)
                Me.m_numatrs = value
            End Set
        End Property


        ' Fields
        Private m_atrcalc As Double
        Private m_atrlength As Integer
        Private m_avgtruerange1 As AvgTrueRange
        Private m_condition1 As Boolean
        Private m_mp As VariableSeries(Of Double)
        Private m_numatrs As Integer
        Private m_Order0 As IOrderPriced
        Private m_Order1 As IOrderPriced
        Private m_poshigh As VariableObject(Of Double)
    End Class
End Namespace

