﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System

Namespace PowerLanguage.Strategy
    Public Class ATR_Trgt_And_Trail_LX
        Inherits SignalObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_atrlength = 5
            Me.m_numatrs = 2
            Me.m_numbars = 5
        End Sub

        Protected Overrides Sub CalcBar()
            Me.m_mp.Value = 0
            If (MyBase.StrategyInfo.MarketPosition > 0) Then
                Me.m_mp.Value = 1
            End If
            If (MyBase.StrategyInfo.MarketPosition < 0) Then
                Me.m_mp.Value = -1
            End If
            If (Me.m_mp.Value = 1) Then
                If (Not Me.m_mp.Item(1) = 1) Then
                    Me.m_targetprice.Value = (Me.EntryPrice() + (Me.m_avgtruerange1.Item(0) * Me.numatrs))
                End If
                If (Me.BarsSinceEntry() < Me.numbars) Then
                    Me.m_Order0.Send(Me.m_targetprice.Value)
                Else
                    Me.m_Order1.Send(MyBase.Bars.Low.Item(0))
                End If
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_avgtruerange1 = New AvgTrueRange(Me)
            Me.m_avgtruerange2 = New AvgTrueRange(Me)
            Me.m_mp = New VariableSeries(Of Double)(Me)
            Me.m_targetprice = New VariableObject(Of Double)(Me)
            Me.m_Order0 = MyBase.OrderCreator.Limit(New SOrderParameters(Contracts.Default, "ATTLX-Tgt", EOrderAction.Sell, OrderExit.FromAll))
            Me.m_Order1 = MyBase.OrderCreator.Stop(New SOrderParameters(Contracts.Default, "ATTLX-Trl", EOrderAction.Sell, OrderExit.FromAll))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_avgtruerange1.length = New Lambda(Of Integer)( Function() Me.atrlength)
            Me.m_avgtruerange2.length = New Lambda(Of Integer)( Function() Me.atrlength)
            Me.m_mp.DefaultValue = 0
            Me.m_targetprice.DefaultValue = 0
        End Sub


        ' Properties
        <Input()> _
        Public Property atrlength As Integer
            Get
                Return Me.m_atrlength
            End Get
            Set(ByVal value As Integer)
                Me.m_atrlength = value
            End Set
        End Property

        <Input()> _
        Public Property numatrs As Integer
            Get
                Return Me.m_numatrs
            End Get
            Set(ByVal value As Integer)
                Me.m_numatrs = value
            End Set
        End Property

        <Input()> _
        Public Property numbars As Integer
            Get
                Return Me.m_numbars
            End Get
            Set(ByVal value As Integer)
                Me.m_numbars = value
            End Set
        End Property


        ' Fields
        Private m_atrlength As Integer
        Private m_avgtruerange1 As AvgTrueRange
        Private m_avgtruerange2 As AvgTrueRange
        Private m_mp As VariableSeries(Of Double)
        Private m_numatrs As Integer
        Private m_numbars As Integer
        Private m_Order0 As IOrderPriced
        Private m_Order1 As IOrderPriced
        Private m_targetprice As VariableObject(Of Double)
    End Class
End Namespace

