﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System

Namespace PowerLanguage.Strategy
    Public Class Bollinger_Bands_LE
        Inherits SignalObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_length = 20
            Me.m_numdevsdn = 2
        End Sub

        Protected Overrides Sub CalcBar()
            Me.m_lowerband.Value = Me.m_bollingerband.Item(0)
            Me.m_condition = ((MyBase.Bars.CurrentBar > 1) AndAlso Me.CrossesOver(Me.testpricelband, Me.m_lowerband))
            If Me.m_condition Then
                Me.m_Order0.Send(Me.m_lowerband.Value)
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_bollingerband = New BollingerBand(Me)
            Me.m_lowerband = New VariableSeries(Of Double)(Me)
            Me.m_Order0 = MyBase.OrderCreator.Stop(New SOrderParameters(Contracts.Default, "BBandLE", EOrderAction.Buy))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_bollingerprice = MyBase.Bars.Close
            Me.m_testpricelband = MyBase.Bars.Close
            Me.m_bollingerband.price = Me.bollingerprice
            Me.m_bollingerband.length = New Lambda(Of Integer)( Function() Me.length)
            Me.m_bollingerband.numdevs = New Lambda(Of Integer)( Function() (-1 * Me.numdevsdn))
            Me.m_condition = False
            Me.m_lowerband.DefaultValue = 0
        End Sub


        ' Properties
        Private ReadOnly Property bollingerprice As ISeries(Of Double)
            Get
                Return Me.m_bollingerprice
            End Get
        End Property

        <Input()> _
        Public Property length As Integer
            Get
                Return Me.m_length
            End Get
            Set(ByVal value As Integer)
                Me.m_length = value
            End Set
        End Property

        <Input()> _
        Public Property numdevsdn As Integer
            Get
                Return Me.m_numdevsdn
            End Get
            Set(ByVal value As Integer)
                Me.m_numdevsdn = value
            End Set
        End Property

        Private ReadOnly Property testpricelband As ISeries(Of Double)
            Get
                Return Me.m_testpricelband
            End Get
        End Property


        ' Fields
        Private m_bollingerband As BollingerBand
        Private m_bollingerprice As ISeries(Of Double)
        Private m_condition As Boolean
        Private m_length As Integer
        Private m_lowerband As VariableSeries(Of Double)
        Private m_numdevsdn As Integer
        Private m_Order0 As IOrderPriced
        Private m_testpricelband As ISeries(Of Double)
    End Class
End Namespace

