﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System

Namespace PowerLanguage.Strategy
    Public Class Bollinger_Bands_SE
        Inherits SignalObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_length = 20
            Me.m_numdevsup = 2
        End Sub

        Protected Overrides Sub CalcBar()
            Me.m_higherband.Value = Me.m_bollingerband.Item(0)
            Me.m_condition = ((MyBase.Bars.CurrentBar > 1) AndAlso Me.CrossesUnder(Me.testpriceuband, Me.m_higherband))
            If Me.m_condition Then
                Me.m_Order.Send(Me.m_higherband.Value)
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_bollingerband = New BollingerBand(Me)
            Me.m_higherband = New VariableSeries(Of Double)(Me)
            Me.m_Order = MyBase.OrderCreator.Stop(New SOrderParameters(Contracts.Default, "BBandSE", EOrderAction.SellShort))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_bollingerprice = MyBase.Bars.Close
            Me.m_testpriceuband = MyBase.Bars.Close
            Me.m_bollingerband.price = Me.bollingerprice
            Me.m_bollingerband.length = New Lambda(Of Integer)( Function() Me.length)
            Me.m_bollingerband.numdevs = New Lambda(Of Integer)( Function() Me.numdevsup)
            Me.m_condition = False
            Me.m_higherband.DefaultValue = 0
        End Sub


        ' Properties
        Private ReadOnly Property bollingerprice As ISeries(Of Double)
            Get
                Return Me.m_bollingerprice
            End Get
        End Property

        <Input()> _
        Public Property length As Integer
            Get
                Return Me.m_length
            End Get
            Set(ByVal value As Integer)
                Me.m_length = value
            End Set
        End Property

        <Input()> _
        Public Property numdevsup As Integer
            Get
                Return Me.m_numdevsup
            End Get
            Set(ByVal value As Integer)
                Me.m_numdevsup = value
            End Set
        End Property

        Private ReadOnly Property testpriceuband As ISeries(Of Double)
            Get
                Return Me.m_testpriceuband
            End Get
        End Property


        ' Fields
        Private m_bollingerband As BollingerBand
        Private m_bollingerprice As ISeries(Of Double)
        Private m_condition As Boolean
        Private m_higherband As VariableSeries(Of Double)
        Private m_length As Integer
        Private m_numdevsup As Integer
        Private m_Order As IOrderPriced
        Private m_testpriceuband As ISeries(Of Double)
    End Class
End Namespace

