﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System

Namespace PowerLanguage.Strategy
    Public Class Channel_Breakout_LE
        Inherits SignalObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_length = 20
        End Sub

        Protected Overrides Sub CalcBar()
            Me.m_Order.Send((Me.m_highestfc.Item(0) + (1 * MyBase.Bars.Point)))
        End Sub

        Protected Overrides Sub Create()
            Me.m_highestfc = New HighestFC(Me)
            Me.m_Order = MyBase.OrderCreator.Stop(New SOrderParameters(Contracts.Default, "ChBrkLE", EOrderAction.Buy))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_price = MyBase.Bars.High
            Me.m_highestfc.pricevalue = Me.price
            Me.m_highestfc.len = New Lambda(Of Integer)( Function() Me.length)
        End Sub


        ' Properties
        <Input> _
        Public Property length As Integer
            Get
                Return Me.m_length
            End Get
            Set(ByVal value As Integer)
                Me.m_length = value
            End Set
        End Property

        Private ReadOnly Property price As ISeries(Of Double)
            Get
                Return Me.m_price
            End Get
        End Property


        ' Fields
        Private m_highestfc As HighestFC
        Private m_length As Integer
        Private m_Order As IOrderPriced
        Private m_price As ISeries(Of Double)
    End Class
End Namespace

