﻿Imports PowerLanguage
Imports System

Namespace PowerLanguage.Strategy
    Public Class Consecutive_Ups_Downs
        Inherits SignalObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_consecutivebarsup = 3
            Me.m_consecutivebarsdown = 3
        End Sub

        Protected Overrides Sub CalcBar()
            If PublicFunctions.DoubleGreater(Me.price.Item(0), Me.price.Item(1)) Then
                Me.m__ups.Value = (Me.m__ups.Value + 1)
            Else
                Me.m__ups.Value = 0
            End If
            If PublicFunctions.DoubleLess(Me.price.Item(0), Me.price.Item(1)) Then
                Me.m__downs.Value = (Me.m__downs.Value + 1)
            Else
                Me.m__downs.Value = 0
            End If
            If PublicFunctions.DoubleGreaterEquals(Me.m__ups.Value, Me.consecutivebarsup) Then
                Me.m_Order0.Send
            End If
            If PublicFunctions.DoubleGreaterEquals(Me.m__downs.Value, Me.consecutivebarsdown) Then
                Me.m_Order1.Send
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m__ups = New VariableObject(Of Double)(Me)
            Me.m__downs = New VariableObject(Of Double)(Me)
            Me.m_Order0 = MyBase.OrderCreator.MarketNextBar(New SOrderParameters(Contracts.Default, "ConsUpLE", EOrderAction.Buy))
            Me.m_Order1 = MyBase.OrderCreator.MarketNextBar(New SOrderParameters(Contracts.Default, "ConsDnSE", EOrderAction.SellShort))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_price = MyBase.Bars.Close
            Me.m__ups.DefaultValue = 0
            Me.m__downs.DefaultValue = 0
        End Sub


        ' Properties
        <Input()> _
        Public Property consecutivebarsdown As Double
            Get
                Return Me.m_consecutivebarsdown
            End Get
            Set(ByVal value As Double)
                Me.m_consecutivebarsdown = value
            End Set
        End Property

        <Input()> _
        Public Property consecutivebarsup As Double
            Get
                Return Me.m_consecutivebarsup
            End Get
            Set(ByVal value As Double)
                Me.m_consecutivebarsup = value
            End Set
        End Property

        Private ReadOnly Property price As ISeries(Of Double)
            Get
                Return Me.m_price
            End Get
        End Property


        ' Fields
        Private m__downs As VariableObject(Of Double)
        Private m__ups As VariableObject(Of Double)
        Private m_consecutivebarsdown As Double
        Private m_consecutivebarsup As Double
        Private m_Order0 As IOrderMarket
        Private m_Order1 As IOrderMarket
        Private m_price As ISeries(Of Double)
    End Class
End Namespace

