﻿Imports PowerLanguage
Imports System

Namespace PowerLanguage.Strategy
    Public Class From_Strategy_To_Broker_MP_Synchronizer
        Inherits SignalObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_timeoutms = 1000
            Me.m_latencyms = 1000
        End Sub

        Protected Overrides Sub CalcBar()
            If (MyBase.Environment.IsRealTimeCalc AndAlso MyBase.Environment.IsAutoTradingMode) Then
                Me.m_inner_mp = MyBase.StrategyInfo.MarketPosition
                Me.m_broker_mp = MyBase.StrategyInfo.MarketPositionAtBroker
                Me.m__rightest = MyBase.Environment.RightScreenTime
                Me.m__highest = MyBase.Environment.HighestScaleValue
                Me.m_textid.Location = New ChartPoint(Me.m__rightest, Me.m__highest)
                If (Me.m_broker_mp <> Me.m_inner_mp) Then
                    Me.m__get_tick_count = DateTime.Now.Ticks
                    If Not If(Me.m_mp_diff.Value, True, Me.m_mp_corrected.Value) Then
                        Me.m_mp_diff.Value = True
                        Me.m_mp_diff_time_start.Value = Me.m__get_tick_count
                        Me.m_textid.Text = Me.m_diff_state
                    End If
                    If ((Me.m_mp_diff.Value AndAlso Not Me.m_mp_corrected.Value) AndAlso PublicFunctions.DoubleGreater((Me.m__get_tick_count - Me.m_mp_diff_time_start.Value), Me.timeoutms)) Then
                        Me.m_place_correction_marketorder.Value = True
                        Me.m_mp_corrected.Value = True
                        Me.m_mp_corrected_time_start.Value = Me.m__get_tick_count
                    End If
                    If Me.m_mp_corrected.Value Then
                        Me.m_textid.Text = Me.m_correction_state
                        If PublicFunctions.DoubleGreater((Me.m__get_tick_count - Me.m_mp_corrected_time_start.Value), Me.latencyms) Then
                            Me.m_mp_corrected_time_start.Value = Me.m__get_tick_count
                            Me.m_mp_diff.Value = False
                            Me.m_mp_corrected.Value = False
                        End If
                    End If
                    If Me.m_place_correction_marketorder.Value Then
                        Me.m_correct_contracts = Math.Abs(CInt((Me.m_broker_mp - Me.m_inner_mp)))
                        Me.m_place_correction_marketorder.Value = False
                        Me.m_is_buy = PublicFunctions.IffLogic(Of Boolean)((Me.m_broker_mp > Me.m_inner_mp), False, True)
                        MyBase.GenerateATMarketOrder(Me.m_is_buy, True, Me.m_correct_contracts)
                    End If
                Else
                    Me.m_textid.Text = Me.m_sync_state
                    Me.m_mp_corrected.Value = False
                    Me.m_mp_diff.Value = False
                End If
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_mp_diff = New VariableObject(Of Boolean)(Me)
            Me.m_mp_diff_time_start = New VariableObject(Of Double)(Me)
            Me.m_mp_corrected = New VariableObject(Of Boolean)(Me)
            Me.m_mp_corrected_time_start = New VariableObject(Of Double)(Me)
            Me.m_place_correction_marketorder = New VariableObject(Of Boolean)(Me)
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_textid = MyBase.DrwText.Create(New ChartPoint(MyBase.Bars.Time.Item(0), MyBase.Bars.Close.Item(0)), "CurrentState")
            Me.m_sync_state = "MP is synchronized!"
            Me.m_diff_state = ("MP syncronization. Wait " & (Me.timeoutms * 0.001) & " seconds.")
            Me.m_correction_state = ("MP correction order sent. Wait " & (Me.latencyms * 0.001) & " seconds.")
            Me.m__highest = 0
            Me.m_inner_mp = 0
            Me.m_broker_mp = 0
            Me.m_mp_diff.DefaultValue = False
            Me.m_mp_diff_time_start.DefaultValue = 0
            Me.m_mp_corrected.DefaultValue = False
            Me.m_mp_corrected_time_start.DefaultValue = 0
            Me.m_place_correction_marketorder.DefaultValue = False
            Me.m__get_tick_count = 0
            Me.m_correct_contracts = 0
            Me.m_is_buy = False
        End Sub


        ' Properties
        <Input()> _
        Public Property latencyms As Double
            Get
                Return Me.m_latencyms
            End Get
            Set(ByVal value As Double)
                Me.m_latencyms = value
            End Set
        End Property

        <Input()> _
        Public Property timeoutms As Double
            Get
                Return Me.m_timeoutms
            End Get
            Set(ByVal value As Double)
                Me.m_timeoutms = value
            End Set
        End Property


        ' Fields
        Private m__get_tick_count As Long
        Private m__highest As Double
        Private m__rightest As DateTime
        Private m_broker_mp As Integer
        Private m_correct_contracts As Integer
        Private m_correction_state As String
        Private m_diff_state As String
        Private m_inner_mp As Integer
        Private m_is_buy As Boolean
        Private m_latencyms As Double
        Private m_mp_corrected As VariableObject(Of Boolean)
        Private m_mp_corrected_time_start As VariableObject(Of Double)
        Private m_mp_diff As VariableObject(Of Boolean)
        Private m_mp_diff_time_start As VariableObject(Of Double)
        Private m_place_correction_marketorder As VariableObject(Of Boolean)
        Private m_sync_state As String
        Private m_textid As ITextObject
        Private m_timeoutms As Double
    End Class
End Namespace

