﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System

Namespace PowerLanguage.Strategy
    Public Class Keltner_Channel_LE
        Inherits SignalObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_length = 20
            Me.m_numatrs = 1.5
        End Sub

        Protected Overrides Sub CalcBar()
            Me.m_avg = Me.m_averagefc1.Item(0)
            Me.m_shift = (Me.numatrs * Me.m_avgtruerange1.Item(0))
            Me.m_upperband.Value = (Me.m_avg + Me.m_shift)
            Me.m_condition1 = ((MyBase.Bars.CurrentBar > 1) AndAlso Me.CrossesOver(Me.price, Me.m_upperband))
            If Me.m_condition1 Then
                Me.m_setupl.Value = True
                Me.m_crossinghigh.Value = MyBase.Bars.High.Item(0)
            Else
                Me.m_condition1 = (Me.m_setupl.Value AndAlso (PublicFunctions.DoubleLess(Me.price.Item(0), Me.m_avg) OrElse PublicFunctions.DoubleGreaterEquals(MyBase.Bars.High.Item(0), (Me.m_crossinghigh.Value + (1 * MyBase.Bars.Point)))))
                If Me.m_condition1 Then
                    Me.m_setupl.Value = False
                End If
            End If
            If Me.m_setupl.Value Then
                Me.m_Order0.Send((Me.m_crossinghigh.Value + (1 * MyBase.Bars.Point)))
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_averagefc1 = New AverageFC(Me)
            Me.m_avgtruerange1 = New AvgTrueRange(Me)
            Me.m_upperband = New VariableSeries(Of Double)(Me)
            Me.m_setupl = New VariableObject(Of Boolean)(Me)
            Me.m_crossinghigh = New VariableObject(Of Double)(Me)
            Me.m_Order0 = MyBase.OrderCreator.Stop(New SOrderParameters(Contracts.Default, "KltChLE", EOrderAction.Buy))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_price = MyBase.Bars.Close
            Me.m_averagefc1.price = Me.price
            Me.m_averagefc1.length = New Lambda(Of Integer)( Function() Me.length)
            Me.m_avgtruerange1.length = New Lambda(Of Integer)( Function() Me.length)
            Me.m_condition1 = False
            Me.m_avg = 0
            Me.m_shift = 0
            Me.m_upperband.DefaultValue = 0
            Me.m_setupl.DefaultValue = False
            Me.m_crossinghigh.DefaultValue = 0
        End Sub


        ' Properties
        <Input()> _
        Public Property length As Integer
            Get
                Return Me.m_length
            End Get
            Set(ByVal value As Integer)
                Me.m_length = value
            End Set
        End Property

        <Input()> _
        Public Property numatrs As Double
            Get
                Return Me.m_numatrs
            End Get
            Set(ByVal value As Double)
                Me.m_numatrs = value
            End Set
        End Property

        Private ReadOnly Property price As ISeries(Of Double)
            Get
                Return Me.m_price
            End Get
        End Property


        ' Fields
        Private m_averagefc1 As AverageFC
        Private m_avg As Double
        Private m_avgtruerange1 As AvgTrueRange
        Private m_condition1 As Boolean
        Private m_crossinghigh As VariableObject(Of Double)
        Private m_length As Integer
        Private m_numatrs As Double
        Private m_Order0 As IOrderPriced
        Private m_price As ISeries(Of Double)
        Private m_setupl As VariableObject(Of Boolean)
        Private m_shift As Double
        Private m_upperband As VariableSeries(Of Double)
    End Class
End Namespace

