﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System

Namespace PowerLanguage.Strategy
    Public Class Keltner_Channel_SE
        Inherits SignalObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_length = 20
            Me.m_numatrs = 1.5
        End Sub

        Protected Overrides Sub CalcBar()
            Me.m_avg = Me.m_averagefc1.Item(0)
            Me.m_shift = (Me.numatrs * Me.m_avgtruerange1.Item(0))
            Me.m_lowerband.Value = (Me.m_avg - Me.m_shift)
            Me.m_condition2 = ((MyBase.Bars.CurrentBar > 1) AndAlso Me.CrossesUnder(Me.price, Me.m_lowerband))
            If Me.m_condition2 Then
                Me.m_setups.Value = True
                Me.m_crossinglow.Value = MyBase.Bars.Low.Item(0)
            Else
                Me.m_condition2 = (Me.m_setups.Value AndAlso (PublicFunctions.DoubleGreater(Me.price.Item(0), Me.m_avg) OrElse PublicFunctions.DoubleLessEquals(MyBase.Bars.Low.Item(0), (Me.m_crossinglow.Value - (1 * MyBase.Bars.Point)))))
                If Me.m_condition2 Then
                    Me.m_setups.Value = False
                End If
            End If
            If Me.m_setups.Value Then
                Me.m_Order1.Send((Me.m_crossinglow.Value - (1 * MyBase.Bars.Point)))
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_averagefc1 = New AverageFC(Me)
            Me.m_avgtruerange1 = New AvgTrueRange(Me)
            Me.m_lowerband = New VariableSeries(Of Double)(Me)
            Me.m_setups = New VariableObject(Of Boolean)(Me)
            Me.m_crossinglow = New VariableObject(Of Double)(Me)
            Me.m_Order1 = MyBase.OrderCreator.Stop(New SOrderParameters(Contracts.Default, "KltChSE", EOrderAction.SellShort))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_price = MyBase.Bars.Close
            Me.m_averagefc1.price = Me.price
            Me.m_averagefc1.length = New Lambda(Of Integer)( Function() Me.length)
            Me.m_avgtruerange1.length = New Lambda(Of Integer)( Function() Me.length)
            Me.m_condition2 = False
            Me.m_avg = 0
            Me.m_shift = 0
            Me.m_lowerband.DefaultValue = 0
            Me.m_setups.DefaultValue = False
            Me.m_crossinglow.DefaultValue = 0
        End Sub


        ' Properties
        <Input()> _
        Public Property length As Integer
            Get
                Return Me.m_length
            End Get
            Set(ByVal value As Integer)
                Me.m_length = value
            End Set
        End Property

        <Input()> _
        Public Property numatrs As Double
            Get
                Return Me.m_numatrs
            End Get
            Set(ByVal value As Double)
                Me.m_numatrs = value
            End Set
        End Property

        Private ReadOnly Property price As ISeries(Of Double)
            Get
                Return Me.m_price
            End Get
        End Property


        ' Fields
        Private m_averagefc1 As AverageFC
        Private m_avg As Double
        Private m_avgtruerange1 As AvgTrueRange
        Private m_condition2 As Boolean
        Private m_crossinglow As VariableObject(Of Double)
        Private m_length As Integer
        Private m_lowerband As VariableSeries(Of Double)
        Private m_numatrs As Double
        Private m_Order1 As IOrderPriced
        Private m_price As ISeries(Of Double)
        Private m_setups As VariableObject(Of Boolean)
        Private m_shift As Double
    End Class
End Namespace

