﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System

Namespace PowerLanguage.Strategy
    Public Class MomentumSE
        Inherits SignalObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_length = 12
        End Sub

        Protected Overrides Sub CalcBar()
            Me.m_mom.Value = Me.m_momentum1.Item(0)
            Me.m_accel = Me.m_momentum2.Item(0)
            If (PublicFunctions.DoubleLess(Me.m_mom.Value, 0) AndAlso PublicFunctions.DoubleLess(Me.m_accel, 0)) Then
                Me.m_Order1.Send((MyBase.Bars.Low.Item(0) - (1 * MyBase.Bars.Point)))
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_momentum1 = New Momentum(Me)
            Me.m_momentum2 = New Momentum(Me)
            Me.m_mom = New VariableSeries(Of Double)(Me)
            Me.m_Order1 = MyBase.OrderCreator.Stop(New SOrderParameters(Contracts.Default, "MomSE", EOrderAction.SellShort))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_price = MyBase.Bars.Close
            Me.m_momentum1.price = Me.price
            Me.m_momentum1.length = New Lambda(Of Integer)( Function() Me.length)
            Me.m_momentum2.price = Me.m_mom
            Me.m_momentum2.length = New ConstantObject(Of Integer)(1)
            Me.m_mom.DefaultValue = 0
            Me.m_accel = 0
        End Sub


        ' Properties
        <Input()> _
        Public Property length As Integer
            Get
                Return Me.m_length
            End Get
            Set(ByVal value As Integer)
                Me.m_length = value
            End Set
        End Property

        Private ReadOnly Property price As ISeries(Of Double)
            Get
                Return Me.m_price
            End Get
        End Property


        ' Fields
        Private m_accel As Double
        Private m_length As Integer
        Private m_mom As VariableSeries(Of Double)
        Private m_momentum1 As Momentum
        Private m_momentum2 As Momentum
        Private m_Order1 As IOrderPriced
        Private m_price As ISeries(Of Double)
    End Class
End Namespace

