﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System

Namespace PowerLanguage.Strategy
    Public Class MovAvg2Line_Cross_SE
        Inherits SignalObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_fastlength = 9
            Me.m_slowlength = &H12
        End Sub

        Protected Overrides Sub CalcBar()
            Me.m_fastavg.Value = Me.m_averagefc1.Item(0)
            Me.m_slowavg.Value = Me.m_averagefc2.Item(0)
            If ((MyBase.Bars.CurrentBar > 1) AndAlso Me.CrossesUnder(Me.m_fastavg, Me.m_slowavg)) Then
                Me.m_Order1.Send
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_averagefc1 = New AverageFC(Me)
            Me.m_averagefc2 = New AverageFC(Me)
            Me.m_fastavg = New VariableSeries(Of Double)(Me)
            Me.m_slowavg = New VariableSeries(Of Double)(Me)
            Me.m_Order1 = MyBase.OrderCreator.MarketNextBar(New SOrderParameters(Contracts.Default, "MA2CrossSE", EOrderAction.SellShort))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_price = MyBase.Bars.Close
            Me.m_averagefc1.price = Me.price
            Me.m_averagefc1.length = New Lambda(Of Integer)( Function() Me.fastlength)
            Me.m_averagefc2.price = Me.price
            Me.m_averagefc2.length = New Lambda(Of Integer)( Function() Me.slowlength)
            Me.m_fastavg.DefaultValue = 0
            Me.m_slowavg.DefaultValue = 0
        End Sub


        ' Properties
        <Input()> _
        Public Property fastlength As Integer
            Get
                Return Me.m_fastlength
            End Get
            Set(ByVal value As Integer)
                Me.m_fastlength = value
            End Set
        End Property

        Private ReadOnly Property price As ISeries(Of Double)
            Get
                Return Me.m_price
            End Get
        End Property

        <Input()> _
        Public Property slowlength As Integer
            Get
                Return Me.m_slowlength
            End Get
            Set(ByVal value As Integer)
                Me.m_slowlength = value
            End Set
        End Property


        ' Fields
        Private m_averagefc1 As AverageFC
        Private m_averagefc2 As AverageFC
        Private m_fastavg As VariableSeries(Of Double)
        Private m_fastlength As Integer
        Private m_Order1 As IOrderMarket
        Private m_price As ISeries(Of Double)
        Private m_slowavg As VariableSeries(Of Double)
        Private m_slowlength As Integer
    End Class
End Namespace

