﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System

Namespace PowerLanguage.Strategy
    Public Class MovAvg3Line_Cross_LE
        Inherits SignalObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_fastlength = 4
            Me.m_medlength = 9
            Me.m_slowlength = &H12
        End Sub

        Protected Overrides Sub CalcBar()
            Me.m_fastavg = Me.m_averagefc1.Item(0)
            Me.m_medavg = Me.m_averagefc2.Item(0)
            Me.m_slowavg = Me.m_averagefc3.Item(0)
            Me.m_condition.Value = ((PublicFunctions.DoubleGreater(Me.price.Item(0), Me.m_fastavg) AndAlso PublicFunctions.DoubleGreater(Me.m_fastavg, Me.m_medavg)) AndAlso PublicFunctions.DoubleGreater(Me.m_medavg, Me.m_slowavg))
            If Not If(((MyBase.Bars.CurrentBar <= 1) OrElse Not Me.m_condition.Value), True, Me.m_condition.Item(1)) Then
                Me.m_Order0.Send
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_averagefc1 = New AverageFC(Me)
            Me.m_averagefc2 = New AverageFC(Me)
            Me.m_averagefc3 = New AverageFC(Me)
            Me.m_condition = New VariableSeries(Of Boolean)(Me)
            Me.m_Order0 = MyBase.OrderCreator.MarketNextBar(New SOrderParameters(Contracts.Default, "MA3CrsLE", EOrderAction.Buy))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_price = MyBase.Bars.Close
            Me.m_averagefc1.price = Me.price
            Me.m_averagefc1.length = New Lambda(Of Integer)( Function() Me.fastlength)
            Me.m_averagefc2.price = Me.price
            Me.m_averagefc2.length = New Lambda(Of Integer)( Function() Me.medlength)
            Me.m_averagefc3.price = Me.price
            Me.m_averagefc3.length = New Lambda(Of Integer)( Function() Me.slowlength)
            Me.m_condition.DefaultValue = False
            Me.m_fastavg = 0
            Me.m_medavg = 0
            Me.m_slowavg = 0
        End Sub


        ' Properties
        <Input> _
        Public Property fastlength As Integer
            Get
                Return Me.m_fastlength
            End Get
            Set(ByVal value As Integer)
                Me.m_fastlength = value
            End Set
        End Property

        <Input> _
        Public Property medlength As Integer
            Get
                Return Me.m_medlength
            End Get
            Set(ByVal value As Integer)
                Me.m_medlength = value
            End Set
        End Property

        Private ReadOnly Property price As ISeries(Of Double)
            Get
                Return Me.m_price
            End Get
        End Property

        <Input()> _
        Public Property slowlength As Integer
            Get
                Return Me.m_slowlength
            End Get
            Set(ByVal value As Integer)
                Me.m_slowlength = value
            End Set
        End Property


        ' Fields
        Private m_averagefc1 As AverageFC
        Private m_averagefc2 As AverageFC
        Private m_averagefc3 As AverageFC
        Private m_condition As VariableSeries(Of Boolean)
        Private m_fastavg As Double
        Private m_fastlength As Integer
        Private m_medavg As Double
        Private m_medlength As Integer
        Private m_Order0 As IOrderMarket
        Private m_price As ISeries(Of Double)
        Private m_slowavg As Double
        Private m_slowlength As Integer
    End Class
End Namespace

