﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System

Namespace PowerLanguage.Strategy
    Public Class MovAvg_Cross_LE
        Inherits SignalObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_length = 9
            Me.m_confirmbars = 1
        End Sub

        Protected Overrides Sub CalcBar()
            Me.m_avg = Me.m_averagefc1.Item(0)
            If PublicFunctions.DoubleGreater(Me.price.Item(0), Me.m_avg) Then
                Me.m_counterl.Value = (Me.m_counterl.Value + 1)
            Else
                Me.m_counterl.Value = 0
            End If
            If (PublicFunctions.DoubleGreater(CDbl(MyBase.Bars.CurrentBar), Me.confirmbars) AndAlso (CDbl(Me.m_counterl.Value) = Me.confirmbars)) Then
                Me.m_Order0.Send
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_averagefc1 = New AverageFC(Me)
            Me.m_counterl = New VariableObject(Of Integer)(Me)
            Me.m_Order0 = MyBase.OrderCreator.MarketNextBar(New SOrderParameters(Contracts.Default, "MACrossLE", EOrderAction.Buy))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_price = MyBase.Bars.Close
            Me.m_averagefc1.price = Me.price
            Me.m_averagefc1.length = New Lambda(Of Integer)( Function() Me.length)
            Me.m_counterl.DefaultValue = 0
            Me.m_avg = 0
        End Sub


        ' Properties
        <Input> _
        Public Property confirmbars As Double
            Get
                Return Me.m_confirmbars
            End Get
            Set(ByVal value As Double)
                Me.m_confirmbars = value
            End Set
        End Property

        <Input> _
        Public Property length As Integer
            Get
                Return Me.m_length
            End Get
            Set(ByVal value As Integer)
                Me.m_length = value
            End Set
        End Property

        Private ReadOnly Property price As ISeries(Of Double)
            Get
                Return Me.m_price
            End Get
        End Property


        ' Fields
        Private m_averagefc1 As AverageFC
        Private m_avg As Double
        Private m_confirmbars As Double
        Private m_counterl As VariableObject(Of Integer)
        Private m_length As Integer
        Private m_Order0 As IOrderMarket
        Private m_price As ISeries(Of Double)
    End Class
End Namespace

