﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System

Namespace PowerLanguage.Strategy
    Public Class Parabolic_SE
        Inherits SignalObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_afstep = 0.02
            Me.m_aflimit = 0.2
        End Sub

        Protected Overrides Sub CalcBar()
            Me.m_value1 = Me.m_parabolicsar1.Item(0)
            If (Me.m_oposition.Value = 1) Then
                Me.m_Order.Send(Me.m_oparop.Value)
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_parabolicsar1 = New ParabolicSAR(Me)
            Me.m_oparcl = New VariableObject(Of Double)(Me)
            Me.m_oparop = New VariableObject(Of Double)(Me)
            Me.m_oposition = New VariableObject(Of Double)(Me)
            Me.m_otransition = New VariableObject(Of Double)(Me)
            Me.m_Order = MyBase.OrderCreator.Stop(New SOrderParameters(Contracts.Default, "ParSE", EOrderAction.SellShort))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_parabolicsar1.afstep = New Lambda(Of Double)( Function() Me.afstep)
            Me.m_parabolicsar1.aflimit = New Lambda(Of Double)( Function() Me.aflimit)
            Me.m_parabolicsar1.oparcl = Me.m_oparcl
            Me.m_parabolicsar1.oparop = Me.m_oparop
            Me.m_parabolicsar1.oposition = Me.m_oposition
            Me.m_parabolicsar1.otransition = Me.m_otransition
            Me.m_value1 = 0
            Me.m_oparcl.DefaultValue = 0
            Me.m_oparop.DefaultValue = 0
            Me.m_oposition.DefaultValue = 0
            Me.m_otransition.DefaultValue = 0
        End Sub


        ' Properties
        <Input()> _
        Public Property aflimit As Double
            Get
                Return Me.m_aflimit
            End Get
            Set(ByVal value As Double)
                Me.m_aflimit = value
            End Set
        End Property

        <Input()> _
        Public Property afstep As Double
            Get
                Return Me.m_afstep
            End Get
            Set(ByVal value As Double)
                Me.m_afstep = value
            End Set
        End Property


        ' Fields
        Private m_aflimit As Double
        Private m_afstep As Double
        Private m_oparcl As VariableObject(Of Double)
        Private m_oparop As VariableObject(Of Double)
        Private m_oposition As VariableObject(Of Double)
        Private m_Order As IOrderPriced
        Private m_otransition As VariableObject(Of Double)
        Private m_parabolicsar1 As ParabolicSAR
        Private m_value1 As Double
    End Class
End Namespace

