﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System

Namespace PowerLanguage.Strategy
    Public Class Parabolic_m_Trail_LX
        Inherits SignalObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_accfactorstep = 0.02
            Me.m_accfactorlimit = 0.2
            Me.m_atrlength = 3
            Me.m_numatrs = 1.5
        End Sub

        Protected Overrides Sub CalcBar()
            Me.m_mp.Value = 0
            If (MyBase.StrategyInfo.MarketPosition > 0) Then
                Me.m_mp.Value = 1
            End If
            If (MyBase.StrategyInfo.MarketPosition < 0) Then
                Me.m_mp.Value = -1
            End If
            If (Me.m_mp.Value = 1) Then
                If (Not Me.m_mp.Item(1) = 1) Then
                    Me.m_stopprice.Value = (MyBase.Bars.Low.Item(0) - (Me.m_avgtruerange.Item(0) * Me.numatrs))
                    Me.m_af.Value = Me.accfactorstep
                    Me.m_tradehh.Value = MyBase.Bars.High.Item(0)
                Else
                    If PublicFunctions.DoubleGreater(MyBase.Bars.High.Item(0), Me.m_tradehh.Value) Then
                        Me.m_tradehh.Value = MyBase.Bars.High.Item(0)
                    End If
                    Me.m_stopprice.Value = (Me.m_stopprice.Value + (Me.m_af.Value * (Me.m_tradehh.Value - Me.m_stopprice.Value)))
                    Me.m_condition1 = (PublicFunctions.DoubleGreater(Me.m_tradehh.Value, Me.m_tradehh.Item(1)) AndAlso PublicFunctions.DoubleLess(Me.m_af.Value, Me.accfactorlimit))
                    If Me.m_condition1 Then
                        Me.m_af.Value = (Me.m_af.Value + PublicFunctions.Min(Me.accfactorstep, New Double() { (Me.accfactorlimit - Me.m_af.Value) }))
                    End If
                End If
                If PublicFunctions.DoubleGreater(Me.m_stopprice.Value, MyBase.Bars.Low.Item(0)) Then
                    Me.m_stopprice.Value = MyBase.Bars.Low.Item(0)
                End If
                Me.m_Order.Send(Me.m_stopprice.Value)
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_avgtruerange = New AvgTrueRange(Me)
            Me.m_mp = New VariableSeries(Of Double)(Me)
            Me.m_stopprice = New VariableObject(Of Double)(Me)
            Me.m_af = New VariableObject(Of Double)(Me)
            Me.m_tradehh = New VariableSeries(Of Double)(Me)
            Me.m_Order = MyBase.OrderCreator.Stop(New SOrderParameters(Contracts.Default, "ParTrLX", EOrderAction.Sell, OrderExit.FromAll))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_avgtruerange.length = New Lambda(Of Integer)( Function() Me.atrlength)
            Me.m_condition1 = False
            Me.m_mp.DefaultValue = 0
            Me.m_stopprice.DefaultValue = 0
            Me.m_af.DefaultValue = 0
            Me.m_tradehh.DefaultValue = 0
        End Sub


        ' Properties
        <Input()> _
        Public Property accfactorlimit As Double
            Get
                Return Me.m_accfactorlimit
            End Get
            Set(ByVal value As Double)
                Me.m_accfactorlimit = value
            End Set
        End Property

        <Input()> _
        Public Property accfactorstep As Double
            Get
                Return Me.m_accfactorstep
            End Get
            Set(ByVal value As Double)
                Me.m_accfactorstep = value
            End Set
        End Property

        <Input()> _
        Public Property atrlength As Integer
            Get
                Return Me.m_atrlength
            End Get
            Set(ByVal value As Integer)
                Me.m_atrlength = value
            End Set
        End Property

        <Input()> _
        Public Property numatrs As Double
            Get
                Return Me.m_numatrs
            End Get
            Set(ByVal value As Double)
                Me.m_numatrs = value
            End Set
        End Property


        ' Fields
        Private m_accfactorlimit As Double
        Private m_accfactorstep As Double
        Private m_af As VariableObject(Of Double)
        Private m_atrlength As Integer
        Private m_avgtruerange As AvgTrueRange
        Private m_condition1 As Boolean
        Private m_mp As VariableSeries(Of Double)
        Private m_numatrs As Double
        Private m_Order As IOrderPriced
        Private m_stopprice As VariableObject(Of Double)
        Private m_tradehh As VariableSeries(Of Double)
    End Class
End Namespace

