﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System

Namespace PowerLanguage.Strategy
    Public Class PercentR_LE
        Inherits SignalObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_length = 14
            Me.m_oversold = 20
            Me.m_overbought = 80
            Me.m_triggerlong = 62
            Me.m_triggershort = 62
        End Sub

        Protected Overrides Sub CalcBar()
            Me.m_mypercentr.Value = Me.m_percentr1.Item(0)
            Me.m_avg.Value = PublicFunctions.Average(MyBase.Bars.Close, Me.length)
            If PublicFunctions.DoubleLess(Me.m_mypercentr.Value, Me.oversold) Then
                Me.m_setupl.Value = True
            ElseIf PublicFunctions.DoubleGreater(Me.m_mypercentr.Value, Me.overbought) Then
                Me.m_setupl.Value = False
            End If
            If ((Me.m_setupl.Value AndAlso PublicFunctions.DoubleGreater(Me.m_avg.Value, Me.m_avg.Item(1))) AndAlso Me.CrossesOver(Me.m_mypercentr, New Lambda(Of Double)( Function() Me.triggerlong))) Then
                Me.m_Order0.Send()
                Me.m_setupl.Value = False
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_percentr1 = New PercentR(Me)
            Me.m_mypercentr = New VariableSeries(Of Double)(Me)
            Me.m_avg = New VariableSeries(Of Double)(Me)
            Me.m_setupl = New VariableObject(Of Boolean)(Me)
            Me.m_Order0 = MyBase.OrderCreator.MarketNextBar(New SOrderParameters(Contracts.Default, "PctRLE", EOrderAction.Buy))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_percentr1.length = New Lambda(Of Integer)( Function() Me.length)
            Me.m_mypercentr.DefaultValue = 0
            Me.m_avg.DefaultValue = 0
            Me.m_setupl.DefaultValue = False
        End Sub


        ' Properties
        <Input()> _
        Public Property length As Integer
            Get
                Return Me.m_length
            End Get
            Set(ByVal value As Integer)
                Me.m_length = value
            End Set
        End Property

        <Input()> _
        Public Property overbought As Double
            Get
                Return Me.m_overbought
            End Get
            Set(ByVal value As Double)
                Me.m_overbought = value
            End Set
        End Property

        <Input()> _
        Public Property oversold As Double
            Get
                Return Me.m_oversold
            End Get
            Set(ByVal value As Double)
                Me.m_oversold = value
            End Set
        End Property

        <Input()> _
        Public Property triggerlong As Double
            Get
                Return Me.m_triggerlong
            End Get
            Set(ByVal value As Double)
                Me.m_triggerlong = value
            End Set
        End Property

        <Input()> _
        Public Property triggershort As Double
            Get
                Return Me.m_triggershort
            End Get
            Set(ByVal value As Double)
                Me.m_triggershort = value
            End Set
        End Property


        ' Fields
        Private m_avg As VariableSeries(Of Double)
        Private m_length As Integer
        Private m_mypercentr As VariableSeries(Of Double)
        Private m_Order0 As IOrderMarket
        Private m_overbought As Double
        Private m_oversold As Double
        Private m_percentr1 As PercentR
        Private m_setupl As VariableObject(Of Boolean)
        Private m_triggerlong As Double
        Private m_triggershort As Double
    End Class
End Namespace

