﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System

Namespace PowerLanguage.Strategy
    Public Class Pivot_Extension_LE
        Inherits SignalObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_leftstrength = 4
            Me.m_rightstrength = 2
        End Sub

        Protected Overrides Sub CalcBar()
            If (Not Me.m_pivotlowvs1.Item(0) = -1) Then
                Me.m_Order0.Send
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_pivotlowvs1 = New PivotLowVS(Me)
            Me.m_Order0 = MyBase.OrderCreator.MarketNextBar(New SOrderParameters(Contracts.Default, "PivExtLE", EOrderAction.Buy))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_lprice = MyBase.Bars.Low
            Me.m_pivotlowvs1.instance = New ConstantObject(Of Integer)(1)
            Me.m_pivotlowvs1.price = Me.lprice
            Me.m_pivotlowvs1.leftstrength = New Lambda(Of Integer)( Function() Me.leftstrength)
            Me.m_pivotlowvs1.rightstrength = New Lambda(Of Integer)( Function() Me.rightstrength)
            Me.m_pivotlowvs1.length = New Lambda(Of Integer)( Function() (Me.rightstrength + 1))
        End Sub


        ' Properties
        <Input> _
        Public Property leftstrength As Integer
            Get
                Return Me.m_leftstrength
            End Get
            Set(ByVal value As Integer)
                Me.m_leftstrength = value
            End Set
        End Property

        Private ReadOnly Property lprice As ISeries(Of Double)
            Get
                Return Me.m_lprice
            End Get
        End Property

        <Input()> _
        Public Property rightstrength As Integer
            Get
                Return Me.m_rightstrength
            End Get
            Set(ByVal value As Integer)
                Me.m_rightstrength = value
            End Set
        End Property


        ' Fields
        Private m_leftstrength As Integer
        Private m_lprice As ISeries(Of Double)
        Private m_Order0 As IOrderMarket
        Private m_pivotlowvs1 As PivotLowVS
        Private m_rightstrength As Integer
    End Class
End Namespace

