﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System

Namespace PowerLanguage.Strategy
    Public Class Pivot_Extension_SE
        Inherits SignalObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_leftstrength = 4
            Me.m_rightstrength = 2
        End Sub

        Protected Overrides Sub CalcBar()
            If (Not Me.m_pivothighvs1.Item(0) = -1) Then
                Me.m_Order1.Send
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_pivothighvs1 = New PivotHighVS(Me)
            Me.m_Order1 = MyBase.OrderCreator.MarketNextBar(New SOrderParameters(Contracts.Default, "PivExtSE", EOrderAction.SellShort))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_sprice = MyBase.Bars.High
            Me.m_pivothighvs1.instance = New ConstantObject(Of Integer)(1)
            Me.m_pivothighvs1.price = Me.sprice
            Me.m_pivothighvs1.leftstrength = New Lambda(Of Integer)( Function() Me.leftstrength)
            Me.m_pivothighvs1.rightstrength = New Lambda(Of Integer)( Function() Me.rightstrength)
            Me.m_pivothighvs1.length = New Lambda(Of Integer)( Function() (Me.rightstrength + 1))
        End Sub


        ' Properties
        <Input> _
        Public Property leftstrength As Integer
            Get
                Return Me.m_leftstrength
            End Get
            Set(ByVal value As Integer)
                Me.m_leftstrength = value
            End Set
        End Property

        <Input> _
        Public Property rightstrength As Integer
            Get
                Return Me.m_rightstrength
            End Get
            Set(ByVal value As Integer)
                Me.m_rightstrength = value
            End Set
        End Property

        Private ReadOnly Property sprice As ISeries(Of Double)
            Get
                Return Me.m_sprice
            End Get
        End Property


        ' Fields
        Private m_leftstrength As Integer
        Private m_Order1 As IOrderMarket
        Private m_pivothighvs1 As PivotHighVS
        Private m_rightstrength As Integer
        Private m_sprice As ISeries(Of Double)
    End Class
End Namespace

