﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System

Namespace PowerLanguage.Strategy
    Public Class Pivot_Reversal_SE
        Inherits SignalObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_strength = 4
        End Sub

        Protected Overrides Sub CalcBar()
            If (Not Me.m_swinglow1.Item(0) = -1) Then
                Me.m_setuplow.Value = True
                Me.m_pivotlow.Value = MyBase.Bars.Low.Item(Me.strength)
            Else
                Me.m_condition1 = (Me.m_setuplow.Value AndAlso PublicFunctions.DoubleLessEquals(MyBase.Bars.Low.Item(0), (Me.m_pivotlow.Value - (1 * MyBase.Bars.Point))))
                If Me.m_condition1 Then
                    Me.m_setuplow.Value = False
                End If
            End If
            If Me.m_setuplow.Value Then
                Me.m_Order1.Send((Me.m_pivotlow.Value - (1 * MyBase.Bars.Point)))
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_swinglow1 = New SwingLow(Me)
            Me.m_setuplow = New VariableObject(Of Boolean)(Me)
            Me.m_pivotlow = New VariableObject(Of Double)(Me)
            Me.m_Order1 = MyBase.OrderCreator.Stop(New SOrderParameters(Contracts.Default, "PivRevSE", EOrderAction.SellShort))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_swinglow1.instance = New ConstantObject(Of Integer)(1)
            Me.m_swinglow1.price = MyBase.Bars.Low
            Me.m_swinglow1.strength = New Lambda(Of Integer)( Function() Me.strength)
            Me.m_swinglow1.length = New Lambda(Of Integer)( Function() (Me.strength + 1))
            Me.m_condition1 = False
            Me.m_setuplow.DefaultValue = False
            Me.m_pivotlow.DefaultValue = 0
        End Sub


        ' Properties
        <Input()> _
        Public Property strength As Integer
            Get
                Return Me.m_strength
            End Get
            Set(ByVal value As Integer)
                Me.m_strength = value
            End Set
        End Property


        ' Fields
        Private m_condition1 As Boolean
        Private m_Order1 As IOrderPriced
        Private m_pivotlow As VariableObject(Of Double)
        Private m_setuplow As VariableObject(Of Boolean)
        Private m_strength As Integer
        Private m_swinglow1 As SwingLow
    End Class
End Namespace

