﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System

Namespace PowerLanguage.Strategy
    Public Class RSI_SE
        Inherits SignalObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_length = 14
            Me.m_overbought = 70
        End Sub

        Protected Overrides Sub CalcBar()
            Me.m_myrsi.Value = Me.m_rsi1.Item(0)
            If ((MyBase.Bars.CurrentBar > 1) AndAlso Me.CrossesUnder(Me.m_myrsi, New Lambda(Of Double)( Function() Me.overbought))) Then
                Me.m_Order1.Send()
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_rsi1 = New RSI(Me)
            Me.m_myrsi = New VariableSeries(Of Double)(Me)
            Me.m_Order1 = MyBase.OrderCreator.MarketNextBar(New SOrderParameters(Contracts.Default, "RsiSE", EOrderAction.SellShort))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_price = MyBase.Bars.Close
            Me.m_rsi1.price = Me.price
            Me.m_rsi1.length = New Lambda(Of Integer)( Function() Me.length)
            Me.m_myrsi.DefaultValue = 0
        End Sub


        ' Properties
        <Input()> _
        Public Property length As Integer
            Get
                Return Me.m_length
            End Get
            Set(ByVal value As Integer)
                Me.m_length = value
            End Set
        End Property

        <Input()> _
        Public Property overbought As Double
            Get
                Return Me.m_overbought
            End Get
            Set(ByVal value As Double)
                Me.m_overbought = value
            End Set
        End Property

        Private ReadOnly Property price As ISeries(Of Double)
            Get
                Return Me.m_price
            End Get
        End Property


        ' Fields
        Private m_length As Integer
        Private m_myrsi As VariableSeries(Of Double)
        Private m_Order1 As IOrderMarket
        Private m_overbought As Double
        Private m_price As ISeries(Of Double)
        Private m_rsi1 As RSI
    End Class
End Namespace

