﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System

Namespace PowerLanguage.Strategy
    Public Class Stochastic_Slow_SE
        Inherits SignalObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_length = 14
            Me.m_overbought = 80
        End Sub

        Protected Overrides Sub CalcBar()
            Me.m_value1 = Me.m_stochastic1.Item(0)
            If (((MyBase.Bars.CurrentBar > 2) AndAlso Me.CrossesUnder(Me.m_oslowk, Me.m_oslowd)) AndAlso PublicFunctions.DoubleGreater(Me.m_oslowk.Value, Me.overbought)) Then
                Me.m_Order1.Send
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_stochastic1 = New Stochastic(Me)
            Me.m_ofastk = New VariableSeries(Of Double)(Me)
            Me.m_ofastd = New VariableSeries(Of Double)(Me)
            Me.m_oslowk = New VariableSeries(Of Double)(Me)
            Me.m_oslowd = New VariableSeries(Of Double)(Me)
            Me.m_Order1 = MyBase.OrderCreator.MarketNextBar(New SOrderParameters(Contracts.Default, "StochSE", EOrderAction.SellShort))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_stochastic1.priceh = MyBase.Bars.High
            Me.m_stochastic1.pricel = MyBase.Bars.Low
            Me.m_stochastic1.pricec = MyBase.Bars.Close
            Me.m_stochastic1.stochlength = New Lambda(Of Integer)( Function() Me.length)
            Me.m_stochastic1.length1 = 3
            Me.m_stochastic1.length2 = New ConstantObject(Of Integer)(3)
            Me.m_stochastic1.smoothingtype = New ConstantObject(Of Integer)(1)
            Me.m_stochastic1.ofastk = Me.m_ofastk
            Me.m_stochastic1.ofastd = Me.m_ofastd
            Me.m_stochastic1.oslowk = Me.m_oslowk
            Me.m_stochastic1.oslowd = Me.m_oslowd
            Me.m_value1 = 0
            Me.m_ofastk.DefaultValue = 0
            Me.m_ofastd.DefaultValue = 0
            Me.m_oslowk.DefaultValue = 0
            Me.m_oslowd.DefaultValue = 0
        End Sub


        ' Properties
        <Input()> _
        Public Property length As Integer
            Get
                Return Me.m_length
            End Get
            Set(ByVal value As Integer)
                Me.m_length = value
            End Set
        End Property

        <Input()> _
        Public Property overbought As Double
            Get
                Return Me.m_overbought
            End Get
            Set(ByVal value As Double)
                Me.m_overbought = value
            End Set
        End Property


        ' Fields
        Private m_length As Integer
        Private m_ofastd As VariableSeries(Of Double)
        Private m_ofastk As VariableSeries(Of Double)
        Private m_Order1 As IOrderMarket
        Private m_oslowd As VariableSeries(Of Double)
        Private m_oslowk As VariableSeries(Of Double)
        Private m_overbought As Double
        Private m_stochastic1 As Stochastic
        Private m_value1 As Double
    End Class
End Namespace

