﻿Imports PowerLanguage
Imports System
Imports System.Collections.Generic
Imports System.Runtime.CompilerServices

Namespace PowerLanguage.Strategy
    Public Class Trendline_SE
        Inherits SignalObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
        End Sub

        Protected Overrides Sub CalcBar()
            If ((Not Me.tlref Is Nothing) AndAlso Me.tlref.Exist) Then
                Me.m_validbar = (MyBase.Bars.Time.Item(0) >= Me.m_btime)
                If (Me.m_validbar AndAlso PublicFunctions.DoubleGreater(MyBase.Bars.Low.Item(0), Me.tlref.PriceValue(MyBase.Bars.Time.Item(0)))) Then
                    Me.m_Order1.Send(Me.tlref.PriceValue(MyBase.Bars.Time.Item(-1)))
                End If
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_Order1 = MyBase.OrderCreator.Stop(New SOrderParameters(Contracts.Default, "Short", EOrderAction.SellShort))
        End Sub

        Protected Overrides Sub StartCalc()
            Dim lines As IEnumerable(Of ITrendLineObject) = MyBase.DrwTrendLine.GetTrendLineObjects(EDrawingSource.AnyTechOrManual)
            Dim drw As ITrendLineObject
            For Each drw In lines
                If (drw.ID = Me.tlid) Then
                    Me.tlref = drw
                    Me.m_btime = Me.tlref.Begin.Time
                End If
            Next
            Me.m_validbar = False
        End Sub


        ' Properties
        Private m_tlid As Integer

        <Input()>
        Public Property tlid() As Integer
            Get
                Return m_tlid
            End Get
            Set(ByVal value As Integer)
                m_tlid = value
            End Set
        End Property

        ' Fields
        Private m_btime As DateTime
        Private m_Order1 As IOrderPriced
        Private m_validbar As Boolean
        Private tlref As ITrendLineObject
    End Class
End Namespace

